"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function javascriptCapabilities() {
    return []; // TODO: Cleanup. Actually populate.
}
function defaultJsEnvironment() {
    return runnerApi.Environment.create({
        urn: exports.TYPESCRIPT_DEFAULT_ENVIRONMENT_URN,
        capabilities: javascriptCapabilities(),
    });
}
defaultJsEnvironment.__closure = () => ({ runnerApi, TYPESCRIPT_DEFAULT_ENVIRONMENT_URN: exports.TYPESCRIPT_DEFAULT_ENVIRONMENT_URN, javascriptCapabilities });
function jsEnvironment(urn, payload, resourceHints = {}, artifacts = []) {
    return {
        urn: urn,
        payload: payload,
        resourceHints: resourceHints,
        dependencies: artifacts,
        capabilities: javascriptCapabilities(),
        displayData: null,
    };
}
jsEnvironment.__closure = () => ({ javascriptCapabilities });
function asNewEnvironment(env, urn, payload) {
    return {
        urn: urn,
        payload: payload,
        resourceHints: env.resourceHints,
        dependencies: env.dependencies,
        capabilities: env.capabilities,
        displayData: env.displayData,
    };
}
function asExternalEnvironment(env, address) {
    return asNewEnvironment(env, "beam:env:external:v1", runnerApi.ExternalPayload.toBinary({
        endpoint: {
            url: address,
            authentication: null,
        },
        params: {},
    }));
}
asExternalEnvironment.__closure = () => ({ asNewEnvironment, runnerApi });
function asDockerEnvironment(env, containerImage) {
    return asNewEnvironment(env, "beam:env:docker:v1", runnerApi.DockerPayload.toBinary({ containerImage: containerImage }));
}
asDockerEnvironment.__closure = () => ({ asNewEnvironment, runnerApi });
Object.defineProperty(exports, "__esModule", { value: true });
exports.asDockerEnvironment = exports.asExternalEnvironment = exports.jsEnvironment = exports.defaultJsEnvironment = exports.TYPESCRIPT_DEFAULT_ENVIRONMENT_URN = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_1;
exports.TYPESCRIPT_DEFAULT_ENVIRONMENT_URN = "js_default";
exports.defaultJsEnvironment = defaultJsEnvironment;
exports.jsEnvironment = jsEnvironment;
exports.asExternalEnvironment = asExternalEnvironment;
exports.asDockerEnvironment = asDockerEnvironment;
//# sourceMappingURL=environments.js.map