"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function objectMap(obj, func) {
    return Object.fromEntries(Object.entries(obj).map((_tct_transform_1 = ([k, v]) => [k, func(v)], _tct_transform_1.__closure = () => ({ func }), _tct_transform_1)));
}
var _tct_transform_1;
objectMap.__closure = () => ({ Object });
function onlyValueOr(valueSet, defaultValue, comparator = (a, b) => false) {
    if (valueSet.size === 0) {
        return defaultValue;
    }
    else if (valueSet.size === 1) {
        return valueSet.values().next().value;
    }
    else {
        const candidate = valueSet.values().next().value;
        for (const other of valueSet) {
            if (!comparator(candidate, other)) {
                throw new Error("Unable to deduce single value from " + valueSet);
            }
        }
        return candidate;
    }
}
onlyValueOr.__closure = () => ({ Error });
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pipeline = exports.PipelineContext = void 0;
const fast_deep_equal_1 = __importStar(require("fast-deep-equal")), _tct_flatten_destructured_imports_1 = fast_deep_equal_1;
var equal = _tct_flatten_destructured_imports_1.default;
const _tct_flatten_destructured_imports_2 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/beam_fn_api"));
var fnApi = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../transforms/transform"));
var PTransformClass = _tct_flatten_destructured_imports_4.PTransformClass;
var AsyncPTransformClass = _tct_flatten_destructured_imports_4.AsyncPTransformClass;
var extractName = _tct_flatten_destructured_imports_4.extractName;
const _tct_flatten_destructured_imports_5 = __importStar(require("../transforms/windowings"));
var globalWindows = _tct_flatten_destructured_imports_5.globalWindows;
const _tct_flatten_destructured_imports_6 = __importStar(require("../pvalue"));
var pvalue = _tct_flatten_destructured_imports_6;
const _tct_flatten_destructured_imports_7 = __importStar(require("../transforms/window"));
var createWindowingStrategyProto = _tct_flatten_destructured_imports_7.createWindowingStrategyProto;
const _tct_flatten_destructured_imports_8 = __importStar(require("./environments"));
var environments = _tct_flatten_destructured_imports_8;
const _tct_flatten_destructured_imports_9 = __importStar(require("../coders/coders"));
var Coder = _tct_flatten_destructured_imports_9.Coder;
var globalCoderRegistry = _tct_flatten_destructured_imports_9.globalRegistry;
// TODO: Cleanup. Where to put this.
class PipelineContext {
    constructor(components) {
        this.components = components;
        this.counter = 0;
        this.coders = {};
    }
    getCoder(coderId) {
        const this_ = this;
        if (this.coders[coderId] === null || this.coders[coderId] === undefined) {
            const coderProto = this.components.coders[coderId];
            const components = (coderProto.componentCoderIds || []).map(this_.getCoder.bind(this_));
            this.coders[coderId] = globalCoderRegistry().getCoder(coderProto.spec.urn, coderProto.spec.payload, ...components);
        }
        return this.coders[coderId];
    }
    getCoderId(coder) {
        return this.getOrAssign(this.components.coders, coder.toProto(this), "coder");
    }
    getPCollectionCoder(pcoll) {
        return this.getCoder(this.getPCollectionCoderId(pcoll));
    }
    getPCollectionCoderId(pcoll) {
        const pcollId = typeof pcoll === "string" ? pcoll : pcoll.getId();
        return this.components.pcollections[pcollId].coderId;
    }
    getWindowingStrategy(id) {
        return this.components.windowingStrategies[id];
    }
    getWindowingStrategyId(windowing) {
        return this.getOrAssign(this.components.windowingStrategies, windowing, "windowing");
    }
    getOrAssign(existing, obj, prefix) {
        for (const [id, other] of Object.entries(existing)) {
            if (equal(other, obj)) {
                return id;
            }
        }
        const newId = this.createUniqueName(prefix);
        existing[newId] = obj;
        return newId;
    }
    createUniqueName(prefix) {
        return prefix + "_" + this.counter++;
    }
}
exports.PipelineContext = PipelineContext;
/**
 * A Pipeline holds the Beam DAG and auxiliary information needed to construct
 * Beam Pipelines.
 */
class Pipeline {
    constructor() {
        this.transformStack = [];
        this.defaultEnvironment = "jsEnvironment";
        this.globalWindowing = "globalWindowing";
        this.proto = runnerApi.Pipeline.create({
            components: runnerApi.Components.create({}),
        });
        this.proto.components.environments[this.defaultEnvironment] =
            environments.defaultJsEnvironment();
        this.context = new PipelineContext(this.proto.components);
        this.proto.components.windowingStrategies[this.globalWindowing] =
            createWindowingStrategyProto(this, globalWindows());
    }
    preApplyTransform(transform, input) {
        const this_ = this;
        const transformId = this.context.createUniqueName("transform");
        let parent = undefined;
        if (this.transformStack.length) {
            parent =
                this.proto.components.transforms[this.transformStack[this.transformStack.length - 1]];
            parent.subtransforms.push(transformId);
        }
        else {
            this.proto.rootTransformIds.push(transformId);
        }
        const transformProto = {
            uniqueName: (parent ? parent.uniqueName + "/" : "") + extractName(transform),
            subtransforms: [],
            inputs: objectMap(pvalue.flattenPValue(input), (pc) => pc.getId()),
            outputs: {},
            environmentId: this.defaultEnvironment,
            displayData: [],
            annotations: {},
        };
        this.proto.components.transforms[transformId] = transformProto;
        return { id: transformId, proto: transformProto };
    }
    applyTransform(transform, input) {
        const { id: transformId, proto: transformProto } = this.preApplyTransform(transform, input);
        let result;
        try {
            this.transformStack.push(transformId);
            result = transform.expandInternal(input, this, transformProto);
        }
        finally {
            this.transformStack.pop();
        }
        return this.postApplyTransform(transform, transformProto, result);
    }
    async asyncApplyTransform(transform, input) {
        const { id: transformId, proto: transformProto } = this.preApplyTransform(transform, input);
        let result;
        try {
            this.transformStack.push(transformId);
            result = await transform.asyncExpandInternal(input, this, transformProto);
        }
        finally {
            this.transformStack.pop();
        }
        return this.postApplyTransform(transform, transformProto, result);
    }
    postApplyTransform(transform, transformProto, result) {
        var _tct_transform_2, _tct_transform_3;
        transformProto.outputs = objectMap(pvalue.flattenPValue(result), (pc) => pc.getId());
        // Propagate any unset pvalue.PCollection properties.
        const this_ = this;
        const inputProtos = Object.values(transformProto.inputs).map((_tct_transform_2 = (id) => this_.proto.components.pcollections[id], _tct_transform_2.__closure = () => ({ this_ }), _tct_transform_2));
        const inputBoundedness = new Set(inputProtos.map((proto) => proto.isBounded));
        const inputWindowings = new Set(inputProtos.map((proto) => proto.windowingStrategyId));
        for (const pcId of Object.values(transformProto.outputs)) {
            const pcProto = this.proto.components.pcollections[pcId];
            if (!pcProto.isBounded) {
                pcProto.isBounded = onlyValueOr(inputBoundedness, runnerApi.IsBounded_Enum.BOUNDED);
            }
            // TODO: (Cleanup) Handle the case of equivalent strategies.
            if (!pcProto.windowingStrategyId) {
                pcProto.windowingStrategyId = onlyValueOr(inputWindowings, this.globalWindowing, (_tct_transform_3 = (a, b) => {
                    return equal(this_.proto.components.windowingStrategies[a], this_.proto.components.windowingStrategies[b]);
                }, _tct_transform_3.__closure = () => ({ equal, this_ }), _tct_transform_3));
            }
        }
        return result;
    }
    createPCollectionInternal(coder, windowingStrategy = undefined, isBounded = undefined) {
        return new pvalue.PCollection(this, this.createPCollectionIdInternal(coder, windowingStrategy, isBounded));
    }
    createPCollectionIdInternal(coder, windowingStrategy = undefined, isBounded = undefined) {
        const pcollId = this.context.createUniqueName("pc");
        let coderId;
        let windowingStrategyId;
        if (typeof coder === "string") {
            coderId = coder;
        }
        else {
            coderId = this.context.getCoderId(coder);
        }
        if (windowingStrategy === null || windowingStrategy === undefined) {
            windowingStrategyId = undefined;
        }
        else if (typeof windowingStrategy === "string") {
            windowingStrategyId = windowingStrategy;
        }
        else {
            windowingStrategyId = this.context.getWindowingStrategyId(windowingStrategy);
        }
        this.proto.components.pcollections[pcollId] = {
            uniqueName: pcollId,
            coderId: coderId,
            isBounded: isBounded,
            windowingStrategyId: windowingStrategyId,
            displayData: [],
        };
        return pcollId;
    }
    getCoder(coderId) {
        return this.context.getCoder(coderId);
    }
    getCoderId(coder) {
        return this.context.getCoderId(coder);
    }
    getProto() {
        return this.proto;
    }
}
exports.Pipeline = Pipeline;
const _tct_flatten_destructured_imports_10 = __importStar(require("../serialization"));
var requireForSerialization = _tct_flatten_destructured_imports_10.requireForSerialization;
requireForSerialization("apache_beam.pipeline", exports);
//# sourceMappingURL=pipeline.js.map