"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
//
function countElements(input) {
    return input
        .map((e) => ({ element: e }))
        .apply(new GroupBy("element").combining("element", count, "count"));
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3;
countElements.__closure = () => ({ GroupBy, count });
function wordCount(lines) {
    return lines
        .map((s) => s.toLowerCase())
        .flatMap(function* (line) {
        yield* line.split(/[^a-z]+/);
    })
        .apply(countElements);
}
wordCount.__closure = () => ({ countElements });
//
// function sqlTransform(query) {
//   return async (pcoll) => {
//     return await pcoll.applyAsync(
//       external.rawExternalTransform(
//         "beam:external:java:sql:v1",
//         { query: query },
//         serviceProviderFromJavaGradleTarget(
//           "sdks:java:extensions:sql:expansion-service:shadowJar"
//         )
//       )
//     );
//   };
// }
//
async function main() {
    // python -m apache_beam.runners.dataflow.dataflow_job_service --port 3333
    // python apache_beam/runners/portability/local_job_service_main.py --port 3333
    const dataflowOptions = {
        project: "apache-beam-testing",
        tempLocation: "gs://temp-storage-for-end-to-end-tests/temp-it",
        region: "us-central1",
        //    environmentType: "LOOPBACK",
        jobEndpoint: "localhost:3333",
    };
    const portableOptions = {
        environmentType: "LOOPBACK",
    };
    //   await beam.createRunner().run(async (root) => {
    await dataflowRunner(dataflowOptions).run((_tct_transform_1 = async (root) => {
        //   await universalRunner(portableOptions).run(async (root) => {
        //    await flinkRunner().run(async (root) => {
        //   await new PortableRunner(options).run(async (root) => {
        const lines = root.apply(beam.create([
            "Aaaa Aaaa Bbbbbbb",
            //         "In the beginning God created the heaven and the earth.",
            //         "And the earth was without form, and void; and darkness was upon the face of the deep.",
            //         "And the Spirit of God moved upon the face of the waters.",
            //         "And God said, Let there be light: and there was light.",
        ]));
        lines.map(console.log);
        lines.apply(wordCount).map(beam.withName("after", console.log));
        //     (
        //       await root.applyAsync(
        //         bigqueryio.readFromTable("bigquery-public-data.samples.shakespeare")
        //       )
        //     ).map(console.log);
        //     const lines = root.apply(
        //       new beam.Create([
        //         "In the beginning God created the heaven and the earth.",
        //         "And the earth was without form, and void; and darkness was upon the face of the deep.",
        //         "And the Spirit of God moved upon the face of the waters.",
        //         "And God said, Let there be light: and there was light.",
        //       ])
        //     );
        //
        //     //lines.apply(wordCount).map(console.log);
        //     (await lines.applyAsync(textio.writeToText('out.txt', {footer: 'the end'}))).filesWritten.map(console.log)
        //
        //     const filtered = await lines //.map((x) => x + "xxx").apply(countElements);
        //       .map((w) => ({ word: w }))
        //       .apply(new internal.WithCoderInternal(RowCoder.fromJSON({ word: "str" })))
        //       .applyAsync(
        //         // java -jar sdks/java/extensions/sql/expansion-service/build/libs/beam-sdks-java-extensions-sql-expansion-service-2.37.0-SNAPSHOT.j 9999
        //         new sql.SqlTransform(
        //           "SELECT word, count(*) as c from PCOLLECTION group by word"
        //           // { word: "str" }
        //         )
        //       );
        //
        //     filtered.map(console.log);
    }, _tct_transform_1.__closure = () => ({ beam, console, wordCount }), _tct_transform_1));
}
main.__closure = () => ({ dataflowRunner, beam, console, wordCount });
Object.defineProperty(exports, "__esModule", { value: true });
// TODO: Should this be in a top-level examples dir, rather than under apache_beam.
const _tct_flatten_destructured_imports_1 = __importStar(require("../../apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
// import * as external from "../../apache_beam/transforms/external";
// import { serviceProviderFromJavaGradleTarget } from "../utils/service";
const _tct_flatten_destructured_imports_2 = __importStar(require("../io/textio"));
var textio = _tct_flatten_destructured_imports_2;
// import * as bigqueryio from "../io/bigqueryio";
//
// import { DirectRunner } from "../runners/direct_runner";
//
const _tct_flatten_destructured_imports_3 = __importStar(require("../transforms/combiners"));
var count = _tct_flatten_destructured_imports_3.count;
const _tct_flatten_destructured_imports_4 = __importStar(require("../transforms/group_and_combine"));
var GroupBy = _tct_flatten_destructured_imports_4.GroupBy;
//
const _tct_flatten_destructured_imports_5 = __importStar(require("../runners/portable_runner/runner"));
var PortableRunner = _tct_flatten_destructured_imports_5.PortableRunner;
//
// import * as internal from "../../apache_beam/transforms/internal";
// import { RowCoder } from "../coders/row_coder";
//
// import * as sql from "../transforms/sql";
//
// //import {flinkRunner} from "../runners/flink"
const _tct_flatten_destructured_imports_6 = __importStar(require("../runners/dataflow"));
var dataflowRunner = _tct_flatten_destructured_imports_6.dataflowRunner;
const _tct_flatten_destructured_imports_7 = __importStar(require("../runners/universal"));
var universalRunner = _tct_flatten_destructured_imports_7.universalRunner;
main()
    .catch((_tct_transform_2 = (e) => console.error(e), _tct_transform_2.__closure = () => ({ console }), _tct_transform_2))
    .finally((_tct_transform_3 = () => process.exit(), _tct_transform_3.__closure = () => ({ process }), _tct_transform_3));
//# sourceMappingURL=wordcount4.js.map