"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
async function main() {
    // python apache_beam/runners/portability/local_job_service_main.py --port 3333
    await new PortableRunner({
        environmentType: "LOOPBACK",
        jobEndpoint: "localhost:3333",
    }).run((_tct_transform_1 = async (root) => {
        const lines = root.apply(beam.create(["a", "b", "c", "c"]));
        const filtered = await lines
            .map((w) => ({ word: w }))
            .apply(beam.withRowCoder({ word: "str" }))
            .applyAsync(sqlTransform("SELECT word, count(*) as c from PCOLLECTION group by word"));
        filtered.map(console.log);
    }, _tct_transform_1.__closure = () => ({ beam, sqlTransform, console }), _tct_transform_1));
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3;
main.__closure = () => ({ PortableRunner, beam, sqlTransform, console });
Object.defineProperty(exports, "__esModule", { value: true });
// TODO: Should this be in a top-level examples dir, rather than under apache_beam.
const _tct_flatten_destructured_imports_1 = __importStar(require("../../apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../../apache_beam/transforms/external"));
var external = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../io/textio"));
var textio = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../runners/portable_runner/runner"));
var PortableRunner = _tct_flatten_destructured_imports_4.PortableRunner;
const _tct_flatten_destructured_imports_5 = __importStar(require("../transforms/sql"));
var sqlTransform = _tct_flatten_destructured_imports_5.sqlTransform;
main()
    .catch((_tct_transform_2 = (e) => console.error(e), _tct_transform_2.__closure = () => ({ console }), _tct_transform_2))
    .finally((_tct_transform_3 = () => process.exit(), _tct_transform_3.__closure = () => ({ process }), _tct_transform_3));
//# sourceMappingURL=wordcount_sql.js.map