"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function readFromAvro(filePattern, 
// TODO: Allow schema to be inferred.
options) {
    return schemaio("readFromTable", "beam:transform:org.apache.beam:schemaio_avro_read:v1", { location: filePattern, schema: options.schema });
}
var _tct_transform_1;
readFromAvro.__closure = () => ({ schemaio });
function writeToAvro(filePath, options) {
    return _tct_transform_1 = async function writeToAvro(pcoll) {
        // TODO: Allow schema to be inferred.
        if (options.schema) {
            pcoll = pcoll.apply(withCoderInternal(RowCoder.fromSchema(options.schema)));
        }
        return pcoll.applyAsync(schemaio("writeToAvro", "beam:transform:org.apache.beam:schemaio_avro_write:v1", { location: filePath, schema: options.schema }));
    }, _tct_transform_1.__closure = () => ({ options, withCoderInternal, RowCoder, schemaio, filePath }), _tct_transform_1;
}
writeToAvro.__closure = () => ({ withCoderInternal, RowCoder, schemaio });
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeToAvro = exports.readFromAvro = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("../../apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../coders/row_coder"));
var RowCoder = _tct_flatten_destructured_imports_2.RowCoder;
const _tct_flatten_destructured_imports_3 = __importStar(require("./schemaio"));
var schemaio = _tct_flatten_destructured_imports_3.schemaio;
const _tct_flatten_destructured_imports_4 = __importStar(require("../proto/schema"));
var Schema = _tct_flatten_destructured_imports_4.Schema;
const _tct_flatten_destructured_imports_5 = __importStar(require("../transforms/internal"));
var withCoderInternal = _tct_flatten_destructured_imports_5.withCoderInternal;
exports.readFromAvro = readFromAvro;
exports.writeToAvro = writeToAvro;
//# sourceMappingURL=avroio.js.map