"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function readFromKafka(consumerConfig, // TODO: Or a map?
topics, options = {}) {
    return readFromKafkaMaybeWithMetadata("readFromKafkaWithMetadata", "beam:transform:org.apache.beam:kafka_read_without_metadata:v1", consumerConfig, topics, options);
}
readFromKafka.__closure = () => ({ readFromKafkaMaybeWithMetadata });
function readFromKafkaWithMetadata(consumerConfig, // TODO: Or a map?
topics, options = {}) {
    return readFromKafkaMaybeWithMetadata("readFromKafkaWithMetadata", "beam:transform:org.apache.beam:kafka_read_with_metadata:v1", consumerConfig, topics, options);
}
readFromKafkaWithMetadata.__closure = () => ({ readFromKafkaMaybeWithMetadata });
function readFromKafkaMaybeWithMetadata(name, urn, consumerConfig, // TODO: Or a map?
topics, options = {}) {
    return beam.withName(name, external.rawExternalTransform(urn, {
        topics,
        consumerConfig,
        ...camelToSnakeOptions({ ...defaultReadFromKafkaOptions, ...options }),
    }, serviceProviderFromJavaGradleTarget(KAFKA_EXPANSION_GRADLE_TARGET)));
}
readFromKafkaMaybeWithMetadata.__closure = () => ({ beam, external, camelToSnakeOptions, defaultReadFromKafkaOptions, serviceProviderFromJavaGradleTarget, KAFKA_EXPANSION_GRADLE_TARGET });
function writeToKafka(producerConfig, // TODO: Or a map?
topics, options = {}) {
    return beam.withName("writeToKafka", external.rawExternalTransform("beam:transform:org.apache.beam:kafka_write:v1", {
        topics,
        producerConfig,
        ...camelToSnakeOptions({ ...defaultWriteToKafkaOptions, ...options }),
    }, serviceProviderFromJavaGradleTarget(KAFKA_EXPANSION_GRADLE_TARGET)));
}
writeToKafka.__closure = () => ({ beam, external, camelToSnakeOptions, defaultWriteToKafkaOptions, serviceProviderFromJavaGradleTarget, KAFKA_EXPANSION_GRADLE_TARGET });
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeToKafka = exports.readFromKafkaWithMetadata = exports.readFromKafka = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("../../apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../transforms/external"));
var external = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/schema"));
var Schema = _tct_flatten_destructured_imports_3.Schema;
const _tct_flatten_destructured_imports_4 = __importStar(require("../coders/row_coder"));
var RowCoder = _tct_flatten_destructured_imports_4.RowCoder;
const _tct_flatten_destructured_imports_5 = __importStar(require("../utils/service"));
var serviceProviderFromJavaGradleTarget = _tct_flatten_destructured_imports_5.serviceProviderFromJavaGradleTarget;
const _tct_flatten_destructured_imports_6 = __importStar(require("protobufjs"));
var protobufjs = _tct_flatten_destructured_imports_6;
const _tct_flatten_destructured_imports_7 = __importStar(require("../utils/utils"));
var camelToSnakeOptions = _tct_flatten_destructured_imports_7.camelToSnakeOptions;
const KAFKA_EXPANSION_GRADLE_TARGET = "sdks:java:io:expansion-service:shadowJar";
const defaultReadFromKafkaOptions = {
    keyDeserializer: "org.apache.kafka.common.serialization.ByteArrayDeserializer",
    valueDeserializer: "org.apache.kafka.common.serialization.ByteArrayDeserializer",
    timestampPolicy: "ProcessingTime",
};
exports.readFromKafka = readFromKafka;
exports.readFromKafkaWithMetadata = readFromKafkaWithMetadata;
const defaultWriteToKafkaOptions = {
    keySerializer: "org.apache.kafka.common.serialization.ByteArraySerializer",
    valueSerializer: "org.apache.kafka.common.serialization.ByteArraySerializer",
};
exports.writeToKafka = writeToKafka;
//# sourceMappingURL=kafka.js.map