"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function flinkRunner(runnerOptions = {}) {
    return new (class extends Runner {
        async runPipeline(pipeline, options = {}) {
            const allOptions = {
                ...defaultOptions,
                ...runnerOptions,
                ...options,
            };
            if (!allOptions.environmentType &&
                MAGIC_HOST_NAMES.includes(allOptions.flinkMaster)) {
                allOptions.environmentType = "LOOPBACK";
            }
            if (!allOptions.artifactsDir) {
                allOptions.artifactsDir = fs.mkdtempSync(path.join(os.tmpdir(), "flinkArtifactsDir"));
            }
            const jobServerJar = allOptions.flinkJobServerJar ||
                (await JavaJarService.cachedJar(JavaJarService.gradleToJar(`runners:flink:${allOptions.flinkVersion}:job-server:shadowJar`)));
            const jobServer = new JavaJarService(jobServerJar, [
                "--flink-master",
                allOptions.flinkMaster,
                "--artifacts-dir",
                allOptions.artifactsDir,
                "--job-port",
                "{{PORT}}",
                "--artifact-port",
                "0",
                "--expansion-port",
                "0",
            ]);
            return new PortableRunner(allOptions, jobServer).runPipeline(pipeline);
        }
    })();
}
flinkRunner.__closure = () => ({ runPipeline, pipeline, options, defaultOptions, MAGIC_HOST_NAMES, fs, path, os, JavaJarService, PortableRunner });
Object.defineProperty(exports, "__esModule", { value: true });
exports.flinkRunner = void 0;
const fs = require("fs");
const os = require("os");
const path = require("path");
const _tct_flatten_destructured_imports_1 = __importStar(require("../internal/pipeline"));
var Pipeline = _tct_flatten_destructured_imports_1.Pipeline;
const _tct_flatten_destructured_imports_2 = __importStar(require("./runner"));
var PipelineResult = _tct_flatten_destructured_imports_2.PipelineResult;
var Runner = _tct_flatten_destructured_imports_2.Runner;
const _tct_flatten_destructured_imports_3 = __importStar(require("./portable_runner/runner"));
var PortableRunner = _tct_flatten_destructured_imports_3.PortableRunner;
const _tct_flatten_destructured_imports_4 = __importStar(require("../utils/service"));
var JavaJarService = _tct_flatten_destructured_imports_4.JavaJarService;
const MAGIC_HOST_NAMES = ["[local]", "[auto]"];
// These should stay in sync with gradle.properties.
const PUBLISHED_FLINK_VERSIONS = ["1.12", "1.13", "1.14"];
const defaultOptions = {
    flinkMaster: "[local]",
    flinkVersion: PUBLISHED_FLINK_VERSIONS[PUBLISHED_FLINK_VERSIONS.length - 1],
};
exports.flinkRunner = flinkRunner;
//# sourceMappingURL=flink.js.map