"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _tct_transform_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.mean = exports.min = exports.max = exports.sum = exports.count = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("./group_and_combine"));
var CombineFn = _tct_flatten_destructured_imports_1.CombineFn;
const _tct_flatten_destructured_imports_2 = __importStar(require("../coders/coders"));
var Coder = _tct_flatten_destructured_imports_2.Coder;
const _tct_flatten_destructured_imports_3 = __importStar(require("../coders/standard_coders"));
var VarIntCoder = _tct_flatten_destructured_imports_3.VarIntCoder;
// TODO(cleanup): These reductions only work on Arrays, not Iterables.
exports.count = {
    createAccumulator: () => 0,
    addInput: (acc, i) => acc + 1,
    mergeAccumulators: (accumulators) => accumulators.reduce((prev, current) => prev + current),
    extractOutput: (acc) => acc,
    accumulatorCoder: (_tct_transform_1 = () => new VarIntCoder(), _tct_transform_1.__closure = () => ({ VarIntCoder }), _tct_transform_1),
};
exports.sum = {
    createAccumulator: () => 0,
    addInput: (acc, i) => acc + i,
    mergeAccumulators: (accumulators) => accumulators.reduce((prev, current) => prev + current),
    extractOutput: (acc) => acc,
    accumulatorCoder: (inputCoder) => inputCoder,
};
exports.max = {
    createAccumulator: () => undefined,
    addInput: (acc, i) => (acc === undefined || acc < i ? i : acc),
    mergeAccumulators: (accumulators) => accumulators
        .filter((x) => x !== undefined)
        .reduce((a, b) => (a > b ? a : b), undefined),
    extractOutput: (acc) => acc,
};
exports.min = {
    createAccumulator: () => undefined,
    addInput: (acc, i) => (acc === undefined || acc > i ? i : acc),
    mergeAccumulators: (accumulators) => accumulators
        .filter((x) => x !== undefined)
        .reduce((a, b) => (a < b ? a : b), undefined),
    extractOutput: (acc) => acc,
};
exports.mean = {
    createAccumulator: () => [0, 0],
    addInput: ([sum, count], i) => [sum + i, count + 1],
    mergeAccumulators: (accumulators) => accumulators.reduce(([sum0, count0], [sum1, count1]) => [
        sum0 + sum1,
        count0 + count1,
    ]),
    extractOutput: ([sum, count]) => sum / count,
};
const _tct_flatten_destructured_imports_4 = __importStar(require("../serialization"));
var requireForSerialization = _tct_flatten_destructured_imports_4.requireForSerialization;
requireForSerialization("apache-beam/transforms/combiners", exports);
//# sourceMappingURL=combiners.js.map