"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
/**
 * A Ptransform that represents a 'static' source with a list of elements passed at construction time. It
 * returns a PCollection that contains the elements in the input list.
 */
function create(elements, reshuffle = true) {
    function create(root) {
        const pcoll = root
            .apply(impulse())
            .flatMap(withName("ExtractElements", (_tct_transform_1 = (_) => elements, _tct_transform_1.__closure = () => ({ elements }), _tct_transform_1)));
        if (elements.length > 1 && reshuffle) {
            return pcoll.apply(utils.reshuffle());
        }
        else {
            return pcoll;
        }
    }
    create.__closure = () => ({ impulse, withName, elements, reshuffle, utils });
    return create;
}
var _tct_transform_1;
create.__closure = () => ({ impulse, withName, utils });
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("./transform"));
var PTransform = _tct_flatten_destructured_imports_1.PTransform;
var withName = _tct_flatten_destructured_imports_1.withName;
const _tct_flatten_destructured_imports_2 = __importStar(require("./internal"));
var impulse = _tct_flatten_destructured_imports_2.impulse;
const _tct_flatten_destructured_imports_3 = __importStar(require("./utils"));
var utils = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../pvalue"));
var Root = _tct_flatten_destructured_imports_4.Root;
var PCollection = _tct_flatten_destructured_imports_4.PCollection;
exports.create = create;
//# sourceMappingURL=create.js.map