"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function groupBy(key, keyName = undefined) {
    return withName(`groupBy(${extractName(key)}`, new GroupBy(key, keyName));
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7, _tct_transform_8, _tct_transform_9, _tct_transform_10;
groupBy.__closure = () => ({ withName, extractName, GroupBy });
function groupGlobally() {
    return new GroupGlobally();
}
groupGlobally.__closure = () => ({ GroupGlobally });
function countPerElement() {
    return withName("countPerElement", groupBy((e) => e, "element").combining((e) => e, count, "count"));
}
countPerElement.__closure = () => ({ withName, groupBy, count });
function countGlobally() {
    return withName("countGlobally", (_tct_transform_1 = (input) => input
        .apply(new GroupGlobally().combining((e) => e, count, "count"))
        .map((o) => o.count), _tct_transform_1.__closure = () => ({ GroupGlobally, count }), _tct_transform_1));
}
countGlobally.__closure = () => ({ withName, GroupGlobally, count });
function toCombineFn(combiner) {
    if (typeof combiner === "function") {
        return binaryCombineFn(combiner);
    }
    else {
        return combiner;
    }
}
toCombineFn.__closure = () => ({ binaryCombineFn });
function binaryCombineFn(combiner) {
    return {
        createAccumulator: () => undefined,
        addInput: (_tct_transform_2 = (a, b) => (a === undefined ? b : combiner(a, b)), _tct_transform_2.__closure = () => ({ combiner }), _tct_transform_2),
        mergeAccumulators: (_tct_transform_3 = (accs) => [...accs].filter((a) => a !== null && a !== undefined).reduce(combiner), _tct_transform_3.__closure = () => ({ combiner }), _tct_transform_3),
        extractOutput: (a) => a,
    };
}
// TODO: (Typescript) Is there a way to indicate type parameters match the above?
function multiCombineFn(combineFns, batchSize = 100) {
    return {
        createAccumulator: (_tct_transform_4 = () => combineFns.map((fn) => fn.createAccumulator()), _tct_transform_4.__closure = () => ({ combineFns }), _tct_transform_4),
        addInput: (_tct_transform_5 = (accumulators, inputs) => {
            // TODO: (Cleanup) Does javascript have a clean zip?
            let result = [];
            for (let i = 0; i < combineFns.length; i++) {
                result.push(combineFns[i].addInput(accumulators[i], inputs[i]));
            }
            return result;
        }, _tct_transform_5.__closure = () => ({ combineFns }), _tct_transform_5),
        mergeAccumulators: (_tct_transform_6 = (accumulators) => {
            let batches = combineFns.map((fn) => [fn.createAccumulator()]);
            for (let acc of accumulators) {
                for (let i = 0; i < combineFns.length; i++) {
                    batches[i].push(acc[i]);
                    if (batches[i].length > batchSize) {
                        batches[i] = [combineFns[i].mergeAccumulators(batches[i])];
                    }
                }
            }
            for (let i = 0; i < combineFns.length; i++) {
                if (batches[i].length > 1) {
                    batches[i] = [combineFns[i].mergeAccumulators(batches[i])];
                }
            }
            return batches.map((batch) => batch[0]);
        }, _tct_transform_6.__closure = () => ({ combineFns, batchSize }), _tct_transform_6),
        extractOutput: (_tct_transform_7 = (accumulators) => {
            // TODO: (Cleanup) Does javascript have a clean zip?
            let result = [];
            for (let i = 0; i < combineFns.length; i++) {
                result.push(combineFns[i].extractOutput(accumulators[i]));
            }
            return result;
        }, _tct_transform_7.__closure = () => ({ combineFns }), _tct_transform_7),
    };
}
// TODO: Consider adding valueFn(s) rather than using the full value.
function coGroupBy(key, keyName = undefined) {
    return withName(`coGroupBy(${extractName(key)})`, (_tct_transform_8 = function coGroupBy(inputs) {
        var _tct_transform_11, _tct_transform_12;
        const [keyFn] = extractFnAndName(key, keyName || "key");
        keyName = typeof keyNames === "string" ? keyNames : "key";
        const tags = [...Object.keys(inputs)];
        const tagged = [...Object.entries(inputs)].map((_tct_transform_11 = ([tag, pcoll]) => {
            var _tct_transform_13;
            return pcoll.map(withName(`map[${tag}]`, (_tct_transform_13 = (element) => ({
                key: keyFn(element),
                tag,
                element,
            }), _tct_transform_13.__closure = () => ({ keyFn, tag }), _tct_transform_13)));
        }, _tct_transform_11.__closure = () => ({ withName, keyFn }), _tct_transform_11));
        return P(tagged)
            .apply(flatten())
            .apply(groupBy("key"))
            .map((_tct_transform_12 = function groupValues({ key, value }) {
            const groupedValues = Object.fromEntries(tags.map((tag) => [tag, []]));
            for (const { tag, element } of value) {
                groupedValues[tag].push(element);
            }
            return { key, values: groupedValues };
        }, _tct_transform_12.__closure = () => ({ Object, tags }), _tct_transform_12));
    }, _tct_transform_8.__closure = () => ({ extractFnAndName, key, keyName, keyNames, Object, withName, P, flatten, groupBy }), _tct_transform_8));
}
coGroupBy.__closure = () => ({ withName, extractName, extractFnAndName, keyNames, Object, P, flatten, groupBy });
// TODO: (Typescript) Can I type T as "something that has this key" and/or,
// even better, ensure it has the correct type?
// Should be possible to get rid of the cast somehow.
// function extractFnAndName<T, P extends keyof T, K = T[P]>(
//   extractor: P | P[] | ((element: T) => K),
//   defaultName: P
// ): [(element: T) => K, P | P[]] {
function extractFnAndName(extractor, defaultName) {
    if (typeof extractor === "string" ||
        typeof extractor === "number" ||
        typeof extractor === "symbol") {
        return [(_tct_transform_9 = (element) => element[extractor], _tct_transform_9.__closure = () => ({ extractor }), _tct_transform_9), extractor];
    }
    else if (extractor instanceof Array) {
        return [
            (_tct_transform_10 = (element) => { var _tct_transform_14; return extractor.map((_tct_transform_14 = (field) => element[field], _tct_transform_14.__closure = () => ({ element }), _tct_transform_14)); }, _tct_transform_10.__closure = () => ({ extractor }), _tct_transform_10),
            extractor,
        ];
    }
    else {
        return [extractor, defaultName];
    }
}
extractFnAndName.__closure = () => ({ Array });
function extractFn(extractor) {
    return extractFnAndName(extractor, undefined)[0];
}
extractFn.__closure = () => ({ extractFnAndName });
Object.defineProperty(exports, "__esModule", { value: true });
exports.coGroupBy = exports.countGlobally = exports.countPerElement = exports.groupGlobally = exports.GroupGlobally = exports.groupBy = exports.GroupBy = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("../values"));
var KV = _tct_flatten_destructured_imports_1.KV;
const _tct_flatten_destructured_imports_2 = __importStar(require("./transform"));
var PTransform = _tct_flatten_destructured_imports_2.PTransform;
var PTransformClass = _tct_flatten_destructured_imports_2.PTransformClass;
var withName = _tct_flatten_destructured_imports_2.withName;
var extractName = _tct_flatten_destructured_imports_2.extractName;
const _tct_flatten_destructured_imports_3 = __importStar(require("./flatten"));
var flatten = _tct_flatten_destructured_imports_3.flatten;
const _tct_flatten_destructured_imports_4 = __importStar(require("../pvalue"));
var PCollection = _tct_flatten_destructured_imports_4.PCollection;
const _tct_flatten_destructured_imports_5 = __importStar(require("../pvalue"));
var PValue = _tct_flatten_destructured_imports_5.PValue;
var P = _tct_flatten_destructured_imports_5.P;
const _tct_flatten_destructured_imports_6 = __importStar(require("../coders/coders"));
var Coder = _tct_flatten_destructured_imports_6.Coder;
const _tct_flatten_destructured_imports_7 = __importStar(require("./internal"));
var internal = _tct_flatten_destructured_imports_7;
const _tct_flatten_destructured_imports_8 = __importStar(require("./combiners"));
var count = _tct_flatten_destructured_imports_8.count;
/**
 * A PTransformClass that takes a PCollection of elements, and returns a PCollection
 * of elements grouped by a field, multiple fields, an expression that is used
 * as the grouping key.
 *
 * @extends PTransformClass
 */
class GroupBy extends PTransformClass {
    /**
     * Create a GroupBy transform.
     *
     * @param key: The name of the key in the JSON object, or a function that returns the key for a given element.
     */
    constructor(key, keyName = undefined) {
        super();
        [this.keyFn, this.keyNames] = extractFnAndName(key, keyName || "key");
        // XXX: Actually use this.
        this.keyName = typeof this.keyNames === "string" ? this.keyNames : "key";
    }
    expand(input) {
        var _tct_transform_15;
        const keyFn = this.keyFn;
        return input
            .map((_tct_transform_15 = (x) => ({ key: keyFn(x), value: x }), _tct_transform_15.__closure = () => ({ keyFn }), _tct_transform_15))
            .apply(internal.groupByKey());
    }
    combining(expr, combiner, resultName) {
        return withName(extractName(this), new GroupByAndCombine(this.keyFn, this.keyNames, []).combining(expr, combiner, resultName));
    }
}
exports.GroupBy = GroupBy;
exports.groupBy = groupBy;
/**
 * Groups all elements of the input PCollection together.
 *
 * This is generally used with one or more combining specifications, as one
 * loses parallelization benefits in bringing all elements of a distributed
 * PCollection together on a single machine.
 */
class GroupGlobally extends PTransformClass {
    constructor() {
        super();
    }
    expand(input) {
        return input.apply(new GroupBy((_) => null)).map((kv) => kv[1]);
    }
    combining(expr, combiner, resultName) {
        return withName(extractName(this), new GroupByAndCombine((_) => null, undefined, []).combining(expr, combiner, resultName));
    }
}
exports.GroupGlobally = GroupGlobally;
exports.groupGlobally = groupGlobally;
class GroupByAndCombine extends PTransformClass {
    constructor(keyFn, keyNames, combiners) {
        super();
        this.keyFn = keyFn;
        this.keyNames = keyNames;
        this.combiners = combiners;
    }
    // TODO: (Naming) Name this combine?
    combining(expr, combiner, resultName // TODO: (Unique names) Optionally derive from expr and combineFn?
    ) {
        return withName(extractName(this), new GroupByAndCombine(this.keyFn, this.keyNames, this.combiners.concat([
            {
                expr: extractFn(expr),
                combineFn: toCombineFn(combiner),
                resultName: resultName,
            },
        ])));
    }
    expand(input) {
        var _tct_transform_16, _tct_transform_17;
        const this_ = this;
        return input
            .map((_tct_transform_16 = function extractKeys(element) {
            var _tct_transform_18;
            return {
                key: this_.keyFn(element),
                value: this_.combiners.map((_tct_transform_18 = (c) => c.expr(element), _tct_transform_18.__closure = () => ({ element }), _tct_transform_18)),
            };
        }, _tct_transform_16.__closure = () => ({ this_ }), _tct_transform_16))
            .apply(internal.combinePerKey(multiCombineFn(this_.combiners.map((c) => c.combineFn))))
            .map((_tct_transform_17 = function constructResult(kv) {
            const result = {};
            if (this_.keyNames === null || this_.keyNames === undefined) {
                // Don't populate a key at all.
            }
            else if (typeof this_.keyNames === "string") {
                result[this_.keyNames] = kv.key;
            }
            else {
                for (let i = 0; i < this_.keyNames.length; i++) {
                    result[this_.keyNames[i]] = kv.key[i];
                }
            }
            for (let i = 0; i < this_.combiners.length; i++) {
                result[this_.combiners[i].resultName] = kv.value[i];
            }
            return result;
        }, _tct_transform_17.__closure = () => ({ this_ }), _tct_transform_17));
    }
}
exports.countPerElement = countPerElement;
exports.countGlobally = countGlobally;
exports.coGroupBy = coGroupBy;
const _tct_flatten_destructured_imports_9 = __importStar(require("../serialization"));
var requireForSerialization = _tct_flatten_destructured_imports_9.requireForSerialization;
requireForSerialization("apache-beam/transforms/pardo", exports);
requireForSerialization("apache-beam/transforms/pardo", {
    GroupByAndCombine: GroupByAndCombine,
});
//# sourceMappingURL=group_and_combine.js.map