"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function withName(name, arg) {
    arg.beamName = name;
    return arg;
}
function extractName(withName) {
    const untyped = withName;
    if (untyped.beamName !== null && untyped.beamName !== undefined) {
        if (typeof untyped.beamName === "string") {
            return untyped.beamName;
        }
        else {
            return untyped.beamName();
        }
    }
    else if (untyped.name && untyped.name !== "anonymous") {
        return untyped.name;
    }
    else {
        const stringified = ("" + withName)
            // Remove injected code coverage boilerplate.
            .replace(/__cov_.*?[+][+]/g, " ")
            // Normalize whitespace.
            .replace(/\s+/gm, " ")
            .trim();
        if (stringified.length < 60) {
            return stringified;
        }
        else {
            throw new Error("Unable to deduce name, please use withName(...).");
        }
    }
}
extractName.__closure = () => ({ Error });
Object.defineProperty(exports, "__esModule", { value: true });
exports.PTransformClass = exports.AsyncPTransformClass = exports.extractName = exports.withName = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../pvalue"));
var PValue = _tct_flatten_destructured_imports_2.PValue;
const _tct_flatten_destructured_imports_3 = __importStar(require("../internal/pipeline"));
var Pipeline = _tct_flatten_destructured_imports_3.Pipeline;
exports.withName = withName;
exports.extractName = extractName;
// NOTE: It could be more idiomatic javascript to simply use the function type
// (InputT, Pipeline, runnerApi.PTransform) => OutputT rather than a transform
// class hierarchy here, a class is chosen to serve as a more obvious
// representative for other languages to follow.
// This more functional form is still preferred for users, and accepted
// as an argument to apply for the various pvalues (see pvalue.ts).
//
// Note also that the requirement for both a synchronous and asynchronous
// variant is imposed by javascript, and is not necessarily relevant in other
// languages (especially if an asynchronous call can be turned into a blocking
// call rather than forcing the asynchronous nature all the way up the call
// hierarchy).
class AsyncPTransformClass {
    constructor(name = null) {
        this.beamName = name || this.constructor.name;
    }
    async expandAsync(input) {
        throw new Error("Method expand has not been implemented.");
    }
    async expandInternalAsync(input, pipeline, transformProto) {
        return this.expandAsync(input);
    }
}
exports.AsyncPTransformClass = AsyncPTransformClass;
class PTransformClass extends AsyncPTransformClass {
    expand(input) {
        throw new Error("Method expand has not been implemented.");
    }
    async expandAsync(input) {
        return this.expand(input);
    }
    expandInternal(input, pipeline, transformProto) {
        return this.expand(input);
    }
    async expandInternalAsync(input, pipeline, transformProto) {
        return this.expandInternal(input, pipeline, transformProto);
    }
}
exports.PTransformClass = PTransformClass;
//# sourceMappingURL=transform.js.map