"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function createWindowingStrategyProto(pipeline, windowFn, windowingStrategyBase = undefined) {
    let result;
    if (windowingStrategyBase === null || windowingStrategyBase === undefined) {
        result = {
            windowFn: undefined,
            windowCoderId: undefined,
            mergeStatus: undefined,
            assignsToOneWindow: undefined,
            trigger: { trigger: { oneofKind: "default", default: {} } },
            accumulationMode: runnerApi.AccumulationMode_Enum.DISCARDING,
            outputTime: runnerApi.OutputTime_Enum.END_OF_WINDOW,
            closingBehavior: runnerApi.ClosingBehavior_Enum.EMIT_ALWAYS,
            onTimeBehavior: runnerApi.OnTimeBehavior_Enum.FIRE_ALWAYS,
            allowedLateness: BigInt(0),
            environmentId: pipeline.defaultEnvironment,
        };
    }
    else {
        result = runnerApi.WindowingStrategy.clone(windowingStrategyBase);
    }
    result.windowFn = windowFn.toProto();
    result.windowCoderId = pipeline.context.getCoderId(windowFn.windowCoder());
    result.mergeStatus = windowFn.isMerging()
        ? runnerApi.MergeStatus_Enum.NEEDS_MERGE
        : runnerApi.MergeStatus_Enum.NON_MERGING;
    result.assignsToOneWindow = windowFn.assignsToOneWindow();
    return result;
}
var _tct_transform_1, _tct_transform_2;
createWindowingStrategyProto.__closure = () => ({ runnerApi, BigInt });
function windowInto(windowFn, windowingStrategyBase = undefined) {
    return withName(`WindowInto(${extractName(windowFn)}, ${windowingStrategyBase})`, (_tct_transform_1 = (input, pipeline, transformProto) => {
        transformProto.spec = runnerApi.FunctionSpec.create({
            urn: parDo.urn,
            payload: runnerApi.ParDoPayload.toBinary(runnerApi.ParDoPayload.create({
                doFn: runnerApi.FunctionSpec.create({
                    urn: urns.JS_WINDOW_INTO_DOFN_URN,
                    payload: serializeFn({ windowFn: windowFn }),
                }),
            })),
        });
        const inputCoder = pipeline.context.getPCollectionCoderId(input);
        return pipeline.createPCollectionInternal(inputCoder, createWindowingStrategyProto(pipeline, windowFn, windowingStrategyBase));
    }, _tct_transform_1.__closure = () => ({ runnerApi, parDo, urns, serializeFn, windowFn, createWindowingStrategyProto, windowingStrategyBase }), _tct_transform_1));
}
windowInto.__closure = () => ({ withName, extractName, runnerApi, parDo, urns, serializeFn, createWindowingStrategyProto });
// TODO: (Cleanup) Add restrictions on moving backwards?
function assignTimestamps(timestampFn) {
    return withName(`assignTimestamp(${extractName(timestampFn)})`, (_tct_transform_2 = (input, pipeline, transformProto) => {
        transformProto.spec = runnerApi.FunctionSpec.create({
            urn: parDo.urn,
            payload: runnerApi.ParDoPayload.toBinary(runnerApi.ParDoPayload.create({
                doFn: runnerApi.FunctionSpec.create({
                    urn: urns.JS_ASSIGN_TIMESTAMPS_DOFN_URN,
                    payload: serializeFn({ func: timestampFn }),
                }),
            })),
        });
        return pipeline.createPCollectionInternal(pipeline.context.getPCollectionCoderId(input));
    }, _tct_transform_2.__closure = () => ({ runnerApi, parDo, urns, serializeFn, timestampFn }), _tct_transform_2));
}
assignTimestamps.__closure = () => ({ withName, extractName, runnerApi, parDo, urns, serializeFn });
Object.defineProperty(exports, "__esModule", { value: true });
exports.assignTimestamps = exports.windowInto = exports.createWindowingStrategyProto = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../internal/urns"));
var urns = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("./transform"));
var PTransform = _tct_flatten_destructured_imports_3.PTransform;
var withName = _tct_flatten_destructured_imports_3.withName;
var extractName = _tct_flatten_destructured_imports_3.extractName;
const _tct_flatten_destructured_imports_4 = __importStar(require("../coders/coders"));
var Coder = _tct_flatten_destructured_imports_4.Coder;
const _tct_flatten_destructured_imports_5 = __importStar(require("../values"));
var Window = _tct_flatten_destructured_imports_5.Window;
const _tct_flatten_destructured_imports_6 = __importStar(require("../pvalue"));
var PCollection = _tct_flatten_destructured_imports_6.PCollection;
const _tct_flatten_destructured_imports_7 = __importStar(require("../internal/pipeline"));
var Pipeline = _tct_flatten_destructured_imports_7.Pipeline;
const _tct_flatten_destructured_imports_8 = __importStar(require("./pardo"));
var parDo = _tct_flatten_destructured_imports_8.parDo;
const _tct_flatten_destructured_imports_9 = __importStar(require("../internal/serialize"));
var serializeFn = _tct_flatten_destructured_imports_9.serializeFn;
exports.createWindowingStrategyProto = createWindowingStrategyProto;
exports.windowInto = windowInto;
exports.assignTimestamps = assignTimestamps;
//# sourceMappingURL=window.js.map