"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function createOperator(transformId, context) {
    const transform = context.descriptor.transforms[transformId];
    // Ensure receivers are eagerly created.
    Object.values(transform.outputs).map(context.getReceiver);
    let operatorConstructor = operatorsByUrn.get(transform.spec.urn);
    if (operatorConstructor === null || operatorConstructor === undefined) {
        throw new Error("Unknown transform type:" + transform.spec.urn);
    }
    return operatorConstructor(transformId, transform, context);
}
var _tct_transform_1, _tct_transform_2;
createOperator.__closure = () => ({ 
    // Ensure receivers are eagerly created.
    Object, operatorsByUrn, Error });
function registerOperator(urn, cls) {
    registerOperatorConstructor(urn, (_tct_transform_1 = (transformId, transformProto, context) => {
        return new cls(transformId, transformProto, context);
    }, _tct_transform_1.__closure = () => ({ cls }), _tct_transform_1));
}
registerOperator.__closure = () => ({ registerOperatorConstructor });
function registerOperatorConstructor(urn, constructor) {
    operatorsByUrn.set(urn, constructor);
}
registerOperatorConstructor.__closure = () => ({ operatorsByUrn });
///
function encodeToBase64(element, coder) {
    const writer = new protobufjs.Writer();
    coder.encode(element, writer, CoderContext.wholeStream);
    return Buffer.from(writer.finish()).toString("base64");
}
encodeToBase64.__closure = () => ({ protobufjs, CoderContext, Buffer });
function decodeFromBase64(s, coder) {
    return coder.decode(new protobufjs.Reader(Buffer.from(s, "base64")), CoderContext.wholeStream);
}
decodeFromBase64.__closure = () => ({ protobufjs, Buffer, CoderContext });
function onlyElement(arg) {
    if (arg.length > 1) {
        Error("Expecting exactly one element.");
    }
    return arg[0];
}
onlyElement.__closure = () => ({ Error });
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeFromBase64 = exports.encodeToBase64 = exports.CombinePerKeyPrecombineOperator = exports.DataSourceOperator = exports.registerOperatorConstructor = exports.registerOperator = exports.createOperator = exports.OperatorContext = exports.Receiver = exports.ProcessResultBuilder = exports.NonPromise = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("protobufjs"));
var protobufjs = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../proto/beam_runner_api"));
var PTransform = _tct_flatten_destructured_imports_2.PTransform;
var PCollection = _tct_flatten_destructured_imports_2.PCollection;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../proto/beam_fn_api"));
var fnApi = _tct_flatten_destructured_imports_4;
const _tct_flatten_destructured_imports_5 = __importStar(require("../proto/beam_fn_api"));
var ProcessBundleDescriptor = _tct_flatten_destructured_imports_5.ProcessBundleDescriptor;
var RemoteGrpcPort = _tct_flatten_destructured_imports_5.RemoteGrpcPort;
const _tct_flatten_destructured_imports_6 = __importStar(require("./data"));
var MultiplexingDataChannel = _tct_flatten_destructured_imports_6.MultiplexingDataChannel;
var IDataChannel = _tct_flatten_destructured_imports_6.IDataChannel;
const _tct_flatten_destructured_imports_7 = __importStar(require("./metrics"));
var MetricsContainer = _tct_flatten_destructured_imports_7.MetricsContainer;
const _tct_flatten_destructured_imports_8 = __importStar(require("./logging"));
var loggingLocalStorage = _tct_flatten_destructured_imports_8.loggingLocalStorage;
var LoggingStageInfo = _tct_flatten_destructured_imports_8.LoggingStageInfo;
const _tct_flatten_destructured_imports_9 = __importStar(require("./state"));
var StateProvider = _tct_flatten_destructured_imports_9.StateProvider;
const _tct_flatten_destructured_imports_10 = __importStar(require("../internal/urns"));
var urns = _tct_flatten_destructured_imports_10;
const _tct_flatten_destructured_imports_11 = __importStar(require("../internal/pipeline"));
var PipelineContext = _tct_flatten_destructured_imports_11.PipelineContext;
const _tct_flatten_destructured_imports_12 = __importStar(require("../internal/serialize"));
var deserializeFn = _tct_flatten_destructured_imports_12.deserializeFn;
const _tct_flatten_destructured_imports_13 = __importStar(require("../coders/coders"));
var Coder = _tct_flatten_destructured_imports_13.Coder;
var CoderContext = _tct_flatten_destructured_imports_13.Context;
const _tct_flatten_destructured_imports_14 = __importStar(require("../values"));
var PaneInfo = _tct_flatten_destructured_imports_14.PaneInfo;
var Window = _tct_flatten_destructured_imports_14.Window;
var Instant = _tct_flatten_destructured_imports_14.Instant;
var WindowedValue = _tct_flatten_destructured_imports_14.WindowedValue;
const _tct_flatten_destructured_imports_15 = __importStar(require("../coders/standard_coders"));
var PaneInfoCoder = _tct_flatten_destructured_imports_15.PaneInfoCoder;
const _tct_flatten_destructured_imports_16 = __importStar(require("../transforms/pardo"));
var parDo = _tct_flatten_destructured_imports_16.parDo;
var DoFn = _tct_flatten_destructured_imports_16.DoFn;
var SplitOptions = _tct_flatten_destructured_imports_16.SplitOptions;
const _tct_flatten_destructured_imports_17 = __importStar(require("../transforms/group_and_combine"));
var CombineFn = _tct_flatten_destructured_imports_17.CombineFn;
const _tct_flatten_destructured_imports_18 = __importStar(require("../transforms/window"));
var WindowFn = _tct_flatten_destructured_imports_18.WindowFn;
const _tct_flatten_destructured_imports_19 = __importStar(require("./pardo_context"));
var ParamProviderImpl = _tct_flatten_destructured_imports_19.ParamProviderImpl;
var SideInputInfo = _tct_flatten_destructured_imports_19.SideInputInfo;
var createSideInputInfo = _tct_flatten_destructured_imports_19.createSideInputInfo;
// Trying to get some of https://github.com/microsoft/TypeScript/issues/8240
exports.NonPromise = null;
class ProcessResultBuilder {
    constructor() {
        this.promises = [];
    }
    add(result) {
        if (result !== exports.NonPromise) {
            this.promises.push(result);
        }
    }
    build() {
        if (this.promises.length === 0) {
            return exports.NonPromise;
        }
        else if (this.promises.length === 1) {
            return this.promises[0];
        }
        else {
            return Promise.all(this.promises).then(() => void null);
        }
    }
}
exports.ProcessResultBuilder = ProcessResultBuilder;
class Receiver {
    constructor(operators, loggingStageInfo, elementCounter) {
        this.operators = operators;
        this.loggingStageInfo = loggingStageInfo;
        this.elementCounter = elementCounter;
    }
    receive(wvalue) {
        this.elementCounter.update(1);
        try {
            if (this.operators.length === 1) {
                const operator = this.operators[0];
                this.loggingStageInfo.transformId = operator.transformId;
                return operator.process(wvalue);
            }
            else {
                const result = new ProcessResultBuilder();
                for (const operator of this.operators) {
                    this.loggingStageInfo.transformId = operator.transformId;
                    result.add(operator.process(wvalue));
                }
                return result.build();
            }
        }
        finally {
            this.loggingStageInfo.transformId = undefined;
        }
    }
}
exports.Receiver = Receiver;
class OperatorContext {
    constructor(descriptor, getReceiver, getDataChannel, getStateProvider, getBundleId, loggingStageInfo, metricsContainer) {
        this.descriptor = descriptor;
        this.getReceiver = getReceiver;
        this.getDataChannel = getDataChannel;
        this.getStateProvider = getStateProvider;
        this.getBundleId = getBundleId;
        this.loggingStageInfo = loggingStageInfo;
        this.metricsContainer = metricsContainer;
        this.pipelineContext = new PipelineContext(descriptor);
    }
}
exports.OperatorContext = OperatorContext;
exports.createOperator = createOperator;
const operatorsByUrn = new Map();
exports.registerOperator = registerOperator;
exports.registerOperatorConstructor = registerOperatorConstructor;
////////// Actual operator implementation. //////////
// NOTE: It may have been more idiomatic to use objects in closures satisfying
// the IOperator interface here, but classes are used to make a clearer pattern
// potential SDK authors that are less familiar with javascript.
class DataSourceOperator {
    constructor(transformId, transform, context) {
        const readPort = RemoteGrpcPort.fromBinary(transform.spec.payload);
        this.multiplexingDataChannel = context.getDataChannel(readPort.apiServiceDescriptor.url);
        this.transformId = transformId;
        this.getBundleId = context.getBundleId;
        this.receiver = context.getReceiver(onlyElement(Object.values(transform.outputs)));
        this.coder = context.pipelineContext.getCoder(readPort.coderId);
        this.loggingStageInfo = context.loggingStageInfo;
        this.started = false;
    }
    async startBundle() {
        var _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7;
        const this_ = this;
        var endOfDataResolve, endOfDataReject;
        this.endOfData = new Promise((_tct_transform_3 = async (resolve, reject) => {
            endOfDataResolve = resolve;
            endOfDataReject = reject;
        }, _tct_transform_3.__closure = () => ({ endOfDataResolve, endOfDataReject }), _tct_transform_3));
        this.lastProcessedElement = -1;
        this.lastToProcessElement = Infinity;
        this.started = true;
        await this_.multiplexingDataChannel.registerConsumer(this_.getBundleId(), this_.transformId, {
            sendData: (_tct_transform_4 = async function (data) {
                var _tct_transform_8;
                this_.loggingStageInfo.transformId = this_.transformId;
                loggingLocalStorage.enterWith(this_.loggingStageInfo);
                const reader = new protobufjs.Reader(data);
                var lastYield = Date.now();
                while (reader.pos < reader.len) {
                    if (this_.lastProcessedElement >= this_.lastToProcessElement) {
                        break;
                    }
                    this_.lastProcessedElement += 1;
                    const maybePromise = this_.receiver.receive(this_.coder.decode(reader, CoderContext.needsDelimiters));
                    if (maybePromise !== exports.NonPromise) {
                        await maybePromise;
                    }
                    // Periodically yield control explicitly to allow other tasks
                    // (including splits requests) to get scheduled.
                    // Note that waiting on a resolved promise is not sufficient, so
                    // we do this in addition to the above loop.
                    if (Date.now() - lastYield > 100 /* milliseconds */) {
                        await new Promise((_tct_transform_8 = (r) => setTimeout(r, 0), _tct_transform_8.__closure = () => ({ setTimeout }), _tct_transform_8));
                        lastYield = new Date().getTime();
                    }
                }
            }, _tct_transform_4.__closure = () => ({ this_, loggingLocalStorage, protobufjs, Date, CoderContext, NonPromise: exports.NonPromise, Promise, setTimeout }), _tct_transform_4),
            sendTimers: (_tct_transform_5 = async function (timerFamilyId, timers) {
                throw Error("Not expecting timers.");
            }, _tct_transform_5.__closure = () => ({ Error }), _tct_transform_5),
            close: (_tct_transform_6 = function () {
                endOfDataResolve();
            }, _tct_transform_6.__closure = () => ({ endOfDataResolve }), _tct_transform_6),
            onError: (_tct_transform_7 = function (error) {
                endOfDataReject(error);
            }, _tct_transform_7.__closure = () => ({ endOfDataReject }), _tct_transform_7),
        });
    }
    process(wvalue) {
        throw Error("Data should not come in via process.");
    }
    split(desiredSplit) {
        var _tct_transform_9;
        if (!this.started) {
            return undefined;
        }
        // If we've already split, we know where the end of this bundle is.
        // Otherwise, use the estimate the runner sent us (which is how much
        // it expects to send us) as the end.
        const end = this.lastToProcessElement < Infinity
            ? this.lastToProcessElement
            : Number(desiredSplit.estimatedInputElements) - 1;
        console.log(this.lastToProcessElement, this.lastProcessedElement, end);
        if (this.lastProcessedElement >= end) {
            return undefined;
        }
        // Split fractionOfRemainder of the way between our current position and
        // the end.
        var targetLastToProcessElement = { value: undefined };
        targetLastToProcessElement.value = Math.floor(this.lastProcessedElement +
            (end - this.lastProcessedElement) * desiredSplit.fractionOfRemainder);
        // If desiredSplit.allowedSplitPoints is populated, try to find the closest
        // split point that's in this list.
        if (desiredSplit.allowedSplitPoints.length) {
            targetLastToProcessElement.value =
                Math.min(...Array.from(desiredSplit.allowedSplitPoints)
                    .filter((_tct_transform_9 = (allowedSplitPoint) => allowedSplitPoint >= targetLastToProcessElement.value + 1, _tct_transform_9.__closure = () => ({ targetLastToProcessElement }), _tct_transform_9))
                    .map(Number)) - 1;
        }
        // If we were able to find a valid, meaningful split point, record it
        // as the last element that this bundle will process and return the
        // remainder to the runner.
        if (this.lastProcessedElement <= targetLastToProcessElement.value &&
            targetLastToProcessElement.value < this.lastToProcessElement) {
            this.lastToProcessElement = targetLastToProcessElement.value;
            return {
                transformId: this.transformId,
                lastPrimaryElement: BigInt(this.lastToProcessElement),
                firstResidualElement: BigInt(this.lastToProcessElement + 1),
            };
        }
        return undefined;
    }
    async finishBundle() {
        try {
            await this.endOfData;
        }
        finally {
            this.multiplexingDataChannel.unregisterConsumer(this.getBundleId(), this.transformId);
            this.started = false;
        }
    }
}
exports.DataSourceOperator = DataSourceOperator;
registerOperator("beam:runner:source:v1", DataSourceOperator);
class DataSinkOperator {
    constructor(transformId, transform, context) {
        const writePort = RemoteGrpcPort.fromBinary(transform.spec.payload);
        this.multiplexingDataChannel = context.getDataChannel(writePort.apiServiceDescriptor.url);
        this.transformId = transformId;
        this.getBundleId = context.getBundleId;
        this.coder = context.pipelineContext.getCoder(writePort.coderId);
    }
    async startBundle() {
        this.channel = this.multiplexingDataChannel.getSendChannel(this.getBundleId(), this.transformId);
        this.buffer = new protobufjs.Writer();
    }
    process(wvalue) {
        this.coder.encode(wvalue, this.buffer, CoderContext.needsDelimiters);
        if (this.buffer.len > 1e6) {
            return this.flush();
        }
        return exports.NonPromise;
    }
    async finishBundle() {
        await this.flush();
        this.channel.close();
    }
    async flush() {
        if (this.buffer.len > 0) {
            await this.channel.sendData(this.buffer.finish());
            this.buffer = new protobufjs.Writer();
        }
    }
}
registerOperator("beam:runner:sink:v1", DataSinkOperator);
class FlattenOperator {
    constructor(transformId, transform, context) {
        this.transformId = transformId;
        this.receiver = context.getReceiver(onlyElement(Object.values(transform.outputs)));
    }
    async startBundle() { }
    process(wvalue) {
        return this.receiver.receive(wvalue);
    }
    async finishBundle() { }
}
registerOperator("beam:transform:flatten:v1", FlattenOperator);
// CombinePerKey operators.
class CombineOperator {
    constructor(transformId, transform, context) {
        this.transformId = transformId;
        this.receiver = context.getReceiver(onlyElement(Object.values(transform.outputs)));
        const spec = runnerApi.CombinePayload.fromBinary(transform.spec.payload);
        this.combineFn = deserializeFn(spec.combineFn.payload).combineFn;
    }
}
class CombinePerKeyPrecombineOperator extends CombineOperator {
    constructor(transformId, transform, context) {
        super(transformId, transform, context);
        this.maxKeys = 10000;
        const inputPc = context.descriptor.pcollections[onlyElement(Object.values(transform.inputs))];
        this.keyCoder = context.pipelineContext.getCoder(context.descriptor.coders[inputPc.coderId].componentCoderIds[0]);
        const windowingStrategy = context.descriptor.windowingStrategies[inputPc.windowingStrategyId];
        CombinePerKeyPrecombineOperator.checkSupportsWindowing(windowingStrategy);
        this.windowCoder = context.pipelineContext.getCoder(windowingStrategy.windowCoderId);
    }
    static checkSupportsWindowing(windowingStrategy) {
        if (windowingStrategy.mergeStatus !== runnerApi.MergeStatus_Enum.NON_MERGING) {
            throw new Error("Unsupported non-merging WindowFn: " + windowingStrategy);
        }
        if (windowingStrategy.outputTime !== runnerApi.OutputTime_Enum.END_OF_WINDOW) {
            throw new Error("Unsupported windowing output time: " + windowingStrategy);
        }
    }
    process(wvalue) {
        for (const window of wvalue.windows) {
            const wkey = encodeToBase64(window, this.windowCoder) +
                " " +
                encodeToBase64(wvalue.value.key, this.keyCoder);
            if (!this.groups.has(wkey)) {
                this.groups.set(wkey, this.combineFn.createAccumulator());
            }
            this.groups.set(wkey, this.combineFn.addInput(this.groups.get(wkey), wvalue.value.value));
        }
        if (this.groups.size > this.maxKeys) {
            // Flush a random 10% of the map to make more room.
            // TODO: Tune this, or better use LRU or ARC for this cache.
            return this.flush(this.maxKeys * 0.9);
        }
        else {
            return exports.NonPromise;
        }
    }
    async startBundle() {
        this.groups = new Map();
    }
    flush(target) {
        const result = new ProcessResultBuilder();
        const toDelete = [];
        for (const [wkey, values] of this.groups) {
            const parts = wkey.split(" ");
            const encodedWindow = parts[0];
            const encodedKey = parts[1];
            const window = decodeFromBase64(encodedWindow, this.windowCoder);
            result.add(this.receiver.receive({
                value: {
                    key: decodeFromBase64(encodedKey, this.keyCoder),
                    value: values,
                },
                windows: [window],
                timestamp: window.maxTimestamp(),
                pane: PaneInfoCoder.ONE_AND_ONLY_FIRING,
            }));
            toDelete.push(wkey);
            if (this.groups.size - toDelete.length <= target) {
                break;
            }
        }
        for (const wkey of toDelete) {
            this.groups.delete(wkey);
        }
        return result.build();
    }
    async finishBundle() {
        const maybePromise = this.flush(0);
        if (maybePromise !== exports.NonPromise) {
            await maybePromise;
        }
        this.groups = null;
    }
}
exports.CombinePerKeyPrecombineOperator = CombinePerKeyPrecombineOperator;
registerOperator("beam:transform:combine_per_key_precombine:v1", CombinePerKeyPrecombineOperator);
class CombinePerKeyMergeAccumulatorsOperator extends CombineOperator {
    async startBundle() { }
    process(wvalue) {
        const { key, value } = wvalue.value;
        return this.receiver.receive({
            value: { key, value: this.combineFn.mergeAccumulators(value) },
            windows: wvalue.windows,
            timestamp: wvalue.timestamp,
            pane: wvalue.pane,
        });
    }
    async finishBundle() { }
}
registerOperator("beam:transform:combine_per_key_merge_accumulators:v1", CombinePerKeyMergeAccumulatorsOperator);
class CombinePerKeyExtractOutputsOperator extends CombineOperator {
    async startBundle() { }
    process(wvalue) {
        const { key, value } = wvalue.value;
        return this.receiver.receive({
            value: { key, value: this.combineFn.extractOutput(value) },
            windows: wvalue.windows,
            timestamp: wvalue.timestamp,
            pane: wvalue.pane,
        });
    }
    async finishBundle() { }
}
registerOperator("beam:transform:combine_per_key_extract_outputs:v1", CombinePerKeyExtractOutputsOperator);
class CombinePerKeyConvertToAccumulatorsOperator extends CombineOperator {
    async startBundle() { }
    process(wvalue) {
        const { key, value } = wvalue.value;
        return this.receiver.receive({
            value: {
                key,
                value: this.combineFn.addInput(this.combineFn.createAccumulator(), value),
            },
            windows: wvalue.windows,
            timestamp: wvalue.timestamp,
            pane: wvalue.pane,
        });
    }
    async finishBundle() { }
}
registerOperator("beam:transform:combine_per_key_convert_to_accumulators:v1", CombinePerKeyConvertToAccumulatorsOperator);
class CombinePerKeyCombineGroupedValuesOperator extends CombineOperator {
    async startBundle() { }
    process(wvalue) {
        const { key, value } = wvalue.value;
        let accumulator = this.combineFn.createAccumulator();
        for (const input of value) {
            accumulator = this.combineFn.addInput(accumulator, input);
        }
        return this.receiver.receive({
            value: {
                key,
                value: this.combineFn.extractOutput(accumulator),
            },
            windows: wvalue.windows,
            timestamp: wvalue.timestamp,
            pane: wvalue.pane,
        });
    }
    async finishBundle() { }
}
registerOperator("beam:transform:combine_grouped_values:v1", CombinePerKeyCombineGroupedValuesOperator);
// ParDo operators.
class GenericParDoOperator {
    constructor(transformId, receiver, spec, payload, transformProto, operatorContext) {
        this.transformId = transformId;
        this.receiver = receiver;
        this.spec = spec;
        this.payload = payload;
        this.sideInputInfo = new Map();
        this.doFn = payload.doFn;
        this.originalContext = payload.context;
        this.getStateProvider = operatorContext.getStateProvider;
        this.sideInputInfo = createSideInputInfo(transformProto, spec, operatorContext);
        this.metricsContainer = operatorContext.metricsContainer;
    }
    async startBundle() {
        this.paramProvider = new ParamProviderImpl(this.transformId, this.sideInputInfo, this.getStateProvider, this.metricsContainer);
        this.augmentedContext = this.paramProvider.augmentContext(this.originalContext);
        if (this.doFn.startBundle) {
            this.doFn.startBundle(this.augmentedContext);
        }
    }
    process(wvalue) {
        function reallyProcess() {
            const doFnOutput = this_.doFn.process(wvalue.value, this_.augmentedContext);
            if (!doFnOutput) {
                return exports.NonPromise;
            }
            const result = new ProcessResultBuilder();
            for (const element of doFnOutput) {
                result.add(this_.receiver.receive({
                    value: element,
                    windows: wvalue.windows,
                    pane: wvalue.pane,
                    timestamp: wvalue.timestamp,
                }));
            }
            this_.paramProvider.setCurrentValue(undefined);
            return result.build();
        }
        var _tct_transform_10;
        reallyProcess.__closure = () => ({ this_, wvalue, NonPromise: exports.NonPromise, ProcessResultBuilder });
        if (this.augmentedContext && wvalue.windows.length !== 1) {
            // We need to process each window separately.
            // TODO: (Perf) We could inspect the context more deeply and allow some
            // cases to go through.
            const result = new ProcessResultBuilder();
            for (const window of wvalue.windows) {
                result.add(this.process({
                    value: wvalue.value,
                    windows: [window],
                    pane: wvalue.pane,
                    timestamp: wvalue.timestamp,
                }));
            }
            return result.build();
        }
        const this_ = this;
        // Update the context with any information specific to this window.
        const updateContextResult = this.paramProvider.setCurrentValue(wvalue);
        // If we were able to do so without any deferred actions, process the
        // element immediately.
        if (updateContextResult === exports.NonPromise) {
            return reallyProcess();
        }
        else {
            // Otherwise return a promise that first waits for all the deferred
            // actions to complete and then process the element.
            return (_tct_transform_10 = async () => {
                await updateContextResult;
                const update2 = this.paramProvider.setCurrentValue(wvalue);
                if (update2 !== exports.NonPromise) {
                    throw new Error("Expected all promises to be resolved: " + update2);
                }
                await reallyProcess();
            }, _tct_transform_10.__closure = () => ({ updateContextResult, wvalue, NonPromise: exports.NonPromise, Error, reallyProcess }), _tct_transform_10)();
        }
    }
    async finishBundle() {
        if (this.doFn.finishBundle) {
            const finishBundleOutput = this.doFn.finishBundle(this.augmentedContext);
            if (!finishBundleOutput) {
                return;
            }
            // The finishBundle method must return `void` or a Generator<WindowedValue<OutputT>>. It may not
            // return Generator<OutputT> without windowing information because a single bundle may contain
            // elements from different windows, so each element must specify its window.
            for (const element of finishBundleOutput) {
                const maybePromise = this.receiver.receive(element);
                if (maybePromise !== exports.NonPromise) {
                    await maybePromise;
                }
            }
        }
    }
}
class IdentityParDoOperator {
    constructor(transformId, receiver) {
        this.transformId = transformId;
        this.receiver = receiver;
    }
    async startBundle() { }
    process(wvalue) {
        return this.receiver.receive(wvalue);
    }
    async finishBundle() { }
}
class SplittingDoFnOperator {
    constructor(transformId, receivers, options) {
        this.transformId = transformId;
        this.receivers = receivers;
        this.options = options;
    }
    async startBundle() { }
    process(wvalue) {
        const result = new ProcessResultBuilder();
        const keys = Object.keys(wvalue.value);
        if (this.options.exclusive && keys.length !== 1) {
            throw new Error("Multiple keys for exclusively split element: " + wvalue.value);
        }
        for (let tag of keys) {
            if (!this.options.knownTags.includes(tag)) {
                if (this.options.unknownTagBehavior === "rename") {
                    tag = this.options.unknownTagName;
                }
                else if (this.options.unknownTagBehavior === "ignore") {
                    continue;
                }
                else {
                    throw new Error("Unexpected tag '" +
                        tag +
                        "' for " +
                        wvalue.value +
                        " not in " +
                        this.options.knownTags);
                }
            }
            const receiver = this.receivers[tag];
            if (receiver) {
                result.add(receiver.receive({
                    value: wvalue.value[tag],
                    windows: wvalue.windows,
                    timestamp: wvalue.timestamp,
                    pane: wvalue.pane,
                }));
            }
        }
        return result.build();
    }
    async finishBundle() { }
}
class AssignWindowsParDoOperator {
    constructor(transformId, receiver, windowFn) {
        this.transformId = transformId;
        this.receiver = receiver;
        this.windowFn = windowFn;
    }
    async startBundle() { }
    process(wvalue) {
        const newWindowsOnce = this.windowFn.assignWindows(wvalue.timestamp);
        if (newWindowsOnce.length > 0) {
            // Each element from each original window is assigned to the new windows.
            const newWindows = [];
            for (var i = 0; i < wvalue.windows.length; i++) {
                newWindows.push(...newWindowsOnce);
            }
            return this.receiver.receive({
                value: wvalue.value,
                windows: newWindows,
                timestamp: wvalue.timestamp,
                pane: wvalue.pane,
            });
        }
        else {
            return exports.NonPromise;
        }
    }
    async finishBundle() { }
}
class AssignTimestampsParDoOperator {
    constructor(transformId, receiver, func) {
        this.transformId = transformId;
        this.receiver = receiver;
        this.func = func;
    }
    async startBundle() { }
    process(wvalue) {
        return this.receiver.receive({
            value: wvalue.value,
            windows: wvalue.windows,
            // TODO: Verify it falls in window and doesn't cause late data.
            timestamp: this.func(wvalue.value, wvalue.timestamp),
            pane: wvalue.pane,
        });
    }
    async finishBundle() { }
}
registerOperatorConstructor(parDo.urn, (_tct_transform_2 = (transformId, transform, context) => {
    var _tct_transform_11;
    const receiver = context.getReceiver(onlyElement(Object.values(transform.outputs)));
    const spec = runnerApi.ParDoPayload.fromBinary(transform.spec.payload);
    // TODO: (Cleanup) Ideally we could branch on the urn itself, but some runners have a closed set of known URNs.
    if (spec.doFn?.urn === urns.SERIALIZED_JS_DOFN_INFO) {
        return new GenericParDoOperator(transformId, context.getReceiver(onlyElement(Object.values(transform.outputs))), spec, deserializeFn(spec.doFn.payload), transform, context);
    }
    else if (spec.doFn?.urn === urns.IDENTITY_DOFN_URN) {
        return new IdentityParDoOperator(transformId, context.getReceiver(onlyElement(Object.values(transform.outputs))));
    }
    else if (spec.doFn?.urn === urns.JS_WINDOW_INTO_DOFN_URN) {
        return new AssignWindowsParDoOperator(transformId, context.getReceiver(onlyElement(Object.values(transform.outputs))), deserializeFn(spec.doFn.payload).windowFn);
    }
    else if (spec.doFn?.urn === urns.JS_ASSIGN_TIMESTAMPS_DOFN_URN) {
        return new AssignTimestampsParDoOperator(transformId, context.getReceiver(onlyElement(Object.values(transform.outputs))), deserializeFn(spec.doFn.payload).func);
    }
    else if (spec.doFn?.urn === urns.SPLITTING_JS_DOFN_URN) {
        return new SplittingDoFnOperator(transformId, Object.fromEntries(Object.entries(transform.outputs).map((_tct_transform_11 = ([tag, pcId]) => [
            tag,
            context.getReceiver(pcId),
        ], _tct_transform_11.__closure = () => ({ context }), _tct_transform_11))), deserializeFn(spec.doFn.payload));
    }
    else {
        throw new Error("Unknown DoFn type: " + spec);
    }
}, _tct_transform_2.__closure = () => ({ onlyElement, Object, runnerApi, urns, GenericParDoOperator, deserializeFn, IdentityParDoOperator, AssignWindowsParDoOperator, AssignTimestampsParDoOperator, SplittingDoFnOperator, Error }), _tct_transform_2));
exports.encodeToBase64 = encodeToBase64;
exports.decodeFromBase64 = decodeFromBase64;
//# sourceMappingURL=operators.js.map