#!/usr/bin/env node
"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
async function main() {
    const argv = yargs.argv;
    let pushLogs;
    if (argv.logging_endpoint) {
        pushLogs = createLoggingChannel(argv.id, argv.logging_endpoint);
    }
    let options = JSON.parse(argv.options);
    if (options["options"]) {
        // Dataflow adds another level of nesting.
        options = options["options"];
    }
    (options["beam:option:registered_node_modules:v1"] ||
        options["registered_node_modules"] ||
        []).forEach(require);
    console.info("Starting worker", argv.id);
    const worker = new Worker(argv.id, {
        controlUrl: argv.control_endpoint,
        //loggingUrl: argv.logging_endpoint,
    }, options);
    if (pushLogs) {
        await pushLogs();
    }
    console.info("Worker started.");
    await worker.wait();
    console.info("Worker stoped.");
}
var _tct_transform_1, _tct_transform_2;
main.__closure = () => ({ yargs, createLoggingChannel, JSON, require, console, Worker });
Object.defineProperty(exports, "__esModule", { value: true });
const _tct_flatten_destructured_imports_1 = __importStar(require("yargs"));
var yargs = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../index"));
var beam = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("./logging"));
var createLoggingChannel = _tct_flatten_destructured_imports_3.createLoggingChannel;
const _tct_flatten_destructured_imports_4 = __importStar(require("./worker"));
var Worker = _tct_flatten_destructured_imports_4.Worker;
var WorkerEndpoints = _tct_flatten_destructured_imports_4.WorkerEndpoints;
main()
    .catch((_tct_transform_1 = (e) => console.error(e), _tct_transform_1.__closure = () => ({ console }), _tct_transform_1))
    .finally((_tct_transform_2 = () => process.exit(), _tct_transform_2.__closure = () => ({ process }), _tct_transform_2));
//# sourceMappingURL=worker_main.js.map