"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _tct_transform_1;
Object.defineProperty(exports, "__esModule", { value: true });
const _tct_flatten_destructured_imports_1 = __importStar(require("chai"));
var expect = _tct_flatten_destructured_imports_1.expect;
const _tct_flatten_destructured_imports_2 = __importStar(require("../src/apache_beam/internal/serialize"));
var serializeFn = _tct_flatten_destructured_imports_2.serializeFn;
var deserializeFn = _tct_flatten_destructured_imports_2.deserializeFn;
describe("serialization tests", (_tct_transform_1 = function () {
    function roundtrip(value) {
        console.log(new TextDecoder().decode(serializeFn(value)));
        return deserializeFn(serializeFn(value));
    }
    var _tct_transform_2, _tct_transform_3, _tct_transform_4;
    roundtrip.__closure = () => ({ console, TextDecoder, serializeFn, deserializeFn });
    function* myGenerator() {
        yield 42;
        yield 84;
    }
    it("serializes and deserializes generators", (_tct_transform_2 = async function () {
        expect(roundtrip(myGenerator)().next()).to.deep.equal({
            value: 42,
            done: false,
        });
        expect([...roundtrip(myGenerator)()]).to.deep.equal([42, 84]);
    }, _tct_transform_2.__closure = () => ({ expect, roundtrip, myGenerator }), _tct_transform_2));
    it("serializes and deserializes function() defined functions", (_tct_transform_3 = async function () {
        // function that returns a simple generator
        const fn1 = function (a) {
            const fn = function* (a) {
                var words = a.split(/[^a-z]+/);
                for (var i = 0; i < words.length; i++) {
                    yield words[i];
                }
            };
            return fn;
        };
        var foo = roundtrip(fn1)("a");
        var bar = fn1("a");
        var foo_itr = foo("kerry is great");
        var bar_itr = bar("kerry is great");
        expect(foo_itr.next()).to.deep.equal(bar_itr.next());
    }, _tct_transform_3.__closure = () => ({ roundtrip, expect }), _tct_transform_3));
    it("serializes and deserializes arrow functions", (_tct_transform_4 = async function () {
        var _tct_transform_5;
        expect(roundtrip((a) => a * a)(2)).to.equal(4);
        const x = 3;
        expect(roundtrip((_tct_transform_5 = (a) => a * x, _tct_transform_5.__closure = () => ({ x }), _tct_transform_5))(2)).to.equal(6);
    }, _tct_transform_4.__closure = () => ({ expect, roundtrip }), _tct_transform_4));
}, _tct_transform_1.__closure = () => ({ console, TextDecoder, serializeFn, deserializeFn, it, expect }), _tct_transform_1));
//# sourceMappingURL=serialize_test.js.map