"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function get_json_value_parser(coderRepr) {
    // TODO(pabloem): support 'beam:coder:row:v1' coder.
    var value_parser_factory = _urn_to_json_value_parser[coderRepr.urn];
    if (value_parser_factory === undefined) {
        throw new Error(util.format("Do not know how to parse example values for %s", coderRepr));
    }
    const components = coderRepr.components || [];
    const componentParsers = components.map((_tct_transform_1 = (componentRepr) => get_json_value_parser(componentRepr), _tct_transform_1.__closure = () => ({ get_json_value_parser }), _tct_transform_1));
    return value_parser_factory(componentParsers);
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7, _tct_transform_8, _tct_transform_9, _tct_transform_10, _tct_transform_11;
get_json_value_parser.__closure = () => ({ _urn_to_json_value_parser, Error, util });
function runCoderTest(coder, urn, context, spec) {
    describe(util.format("coder %s (%s)", util.inspect(coder, { colors: true, breakLength: Infinity }), spec.coder.non_deterministic ? "nondeterministic" : "deterministic"), (_tct_transform_2 = function () {
        const parser = get_json_value_parser(spec.coder);
        for (let expected in spec.examples) {
            var value = parser(spec.examples[expected]);
            const expectedEncoded = Buffer.from(expected, "binary");
            if ((UNSUPPORTED_EXAMPLES[spec.coder.urn] || []).includes(expectedEncoded.toString("hex"))) {
                continue;
            }
            coderCase(coder, value, expectedEncoded, context, spec.coder.non_deterministic || false);
        }
    }, _tct_transform_2.__closure = () => ({ get_json_value_parser, spec, Buffer, UNSUPPORTED_EXAMPLES, coderCase, coder, context }), _tct_transform_2));
}
runCoderTest.__closure = () => ({ describe, util, Infinity, get_json_value_parser, Buffer, UNSUPPORTED_EXAMPLES, coderCase });
function coderCase(coder, obj, expectedEncoded, context, non_deterministic) {
    let encodeObj = { value: undefined };
    // Normally we would not support non-deterministic cases, but in the
    // implementation that we have, the non-deterministic encodings happen
    // to match our samples.
    if (non_deterministic && coder instanceof IterableCoder) {
        // We support the particular case of iterables of unknown length.
        // The encoding here is not deterministic, but the test case works
        // fine.
        let typedIterable = (_tct_transform_3 = function* it() {
            for (let elm in obj) {
                yield obj[elm];
            }
        }, _tct_transform_3.__closure = () => ({ obj }), _tct_transform_3)();
        encodeObj.value = typedIterable;
    }
    else {
        encodeObj.value = obj;
    }
    it(util.format("encodes %s to %s", util.inspect(encodeObj.value, { colors: true, depth: Infinity }), Buffer.from(expectedEncoded).toString("hex")), (_tct_transform_4 = function () {
        var writer = new Writer();
        coder.encode(encodeObj.value, writer, context);
        assertions.deepEqual(writer.finish(), expectedEncoded);
    }, _tct_transform_4.__closure = () => ({ Writer, coder, encodeObj, context, assertions, expectedEncoded }), _tct_transform_4));
    it(util.format("decodes %s to %s correctly", Buffer.from(expectedEncoded).toString("hex"), util.inspect(obj, { colors: true, depth: Infinity })), (_tct_transform_5 = function () {
        const decoded = coder.decode(new Reader(expectedEncoded), context);
        assertions.deepEqual(decoded, obj);
    }, _tct_transform_5.__closure = () => ({ coder, Reader, expectedEncoded, context, assertions, obj }), _tct_transform_5));
}
coderCase.__closure = () => ({ IterableCoder, util, Infinity, Buffer, Writer, assertions, Reader });
Object.defineProperty(exports, "__esModule", { value: true });
const _tct_flatten_destructured_imports_1 = __importStar(require("../src/apache_beam/coders/coders"));
var Coder = _tct_flatten_destructured_imports_1.Coder;
var Context = _tct_flatten_destructured_imports_1.Context;
var globalRegistry = _tct_flatten_destructured_imports_1.globalRegistry;
const _tct_flatten_destructured_imports_2 = __importStar(require("protobufjs"));
var Writer = _tct_flatten_destructured_imports_2.Writer;
var Reader = _tct_flatten_destructured_imports_2.Reader;
const long_1 = __importStar(require("long")), _tct_flatten_destructured_imports_3 = long_1;
var Long = _tct_flatten_destructured_imports_3.default;
const assertions = require("assert");
const yaml = require("js-yaml");
const fs = require("fs");
const util = require("util");
const _tct_flatten_destructured_imports_4 = __importStar(require("../src/apache_beam/values"));
var GlobalWindow = _tct_flatten_destructured_imports_4.GlobalWindow;
var Timing = _tct_flatten_destructured_imports_4.Timing;
const _tct_flatten_destructured_imports_5 = __importStar(require("../src/apache_beam/coders/required_coders"));
var IterableCoder = _tct_flatten_destructured_imports_5.IterableCoder;
const STANDARD_CODERS_FILE = "../../model/fn-execution/src/main/resources/org/apache/beam/model/fnexecution/v1/standard_coders.yaml";
// TODO(pabloem): Empty this list.
const UNSUPPORTED_CODERS = [
    "beam:coder:timer:v1",
    "beam:coder:param_windowed_value:v1",
    "beam:coder:sharded_key:v1",
    "beam:coder:custom_window:v1",
    "beam:coder:state_backed_iterable:v1",
    // Tested elsewhere (though it'd still be good to enable).
    "beam:coder:row:v1",
];
const UNSUPPORTED_EXAMPLES = {
    // Floating point truncation when parsing json definition.
    "beam:coder:interval_window:v1": ["8020c49ba5e353f700"],
};
const _urn_to_json_value_parser = {
    "beam:coder:bytes:v1": (_tct_transform_6 = (_) => { var _tct_transform_12; return _tct_transform_12 = (x) => new TextEncoder().encode(x), _tct_transform_12.__closure = () => ({ TextEncoder }), _tct_transform_12; }, _tct_transform_6.__closure = () => ({ TextEncoder }), _tct_transform_6),
    "beam:coder:bool:v1": (_) => (x) => x,
    "beam:coder:string_utf8:v1": (_) => (x) => x,
    "beam:coder:varint:v1": (_) => (x) => x,
    "beam:coder:double:v1": (_tct_transform_7 = (_) => { var _tct_transform_13; return _tct_transform_13 = (x) => x === "NaN" ? NaN : x, _tct_transform_13.__closure = () => ({ NaN }), _tct_transform_13; }, _tct_transform_7.__closure = () => ({ NaN }), _tct_transform_7),
    "beam:coder:kv:v1": (components) => { var _tct_transform_14; return _tct_transform_14 = (x) => ({
        key: components[0](x["key"]),
        value: components[1](x["value"]),
    }), _tct_transform_14.__closure = () => ({ components }), _tct_transform_14; },
    "beam:coder:iterable:v1": (components) => { var _tct_transform_15; return _tct_transform_15 = (x) => { var _tct_transform_16; return x.map((_tct_transform_16 = (elm) => components[0](elm), _tct_transform_16.__closure = () => ({ components }), _tct_transform_16)); }, _tct_transform_15.__closure = () => ({ components }), _tct_transform_15; },
    "beam:coder:global_window:v1": (_tct_transform_8 = (_) => { var _tct_transform_17; return _tct_transform_17 = (x) => new GlobalWindow(), _tct_transform_17.__closure = () => ({ GlobalWindow }), _tct_transform_17; }, _tct_transform_8.__closure = () => ({ GlobalWindow }), _tct_transform_8),
    "beam:coder:interval_window:v1": (_tct_transform_9 = (_) => { var _tct_transform_18; return _tct_transform_18 = (x) => ({
        start: Long.fromNumber(x.end).sub(x.span),
        end: Long.fromNumber(x.end),
    }), _tct_transform_18.__closure = () => ({ Long }), _tct_transform_18; }, _tct_transform_9.__closure = () => ({ Long }), _tct_transform_9),
    "beam:coder:windowed_value:v1": (_tct_transform_10 = (components) => { var _tct_transform_19; return _tct_transform_19 = (x) => ({
        value: components[0](x.value),
        windows: x.windows.map(components[1]),
        pane: {
            isLast: x.pane.is_last,
            isFirst: x.pane.is_first,
            index: x.pane.index,
            onTimeIndex: x.pane.on_time_index,
            timing: Timing[x.pane.timing],
        },
        timestamp: Long.fromNumber(x.timestamp),
    }), _tct_transform_19.__closure = () => ({ components, Timing, Long }), _tct_transform_19; }, _tct_transform_10.__closure = () => ({ Timing, Long }), _tct_transform_10),
    "beam:coder:nullable:v1": (components) => { var _tct_transform_20; return _tct_transform_20 = (x) => {
        return x === null || x === undefined ? undefined : components[0](x);
    }, _tct_transform_20.__closure = () => ({ components }), _tct_transform_20; },
};
describe("standard Beam coders on Javascript", (_tct_transform_11 = function () {
    var _tct_transform_21;
    const docs = yaml.loadAll(fs.readFileSync(STANDARD_CODERS_FILE, "utf8"));
    docs.forEach((_tct_transform_21 = (doc) => {
        var _tct_transform_22;
        const urn = doc.coder.urn;
        if (UNSUPPORTED_CODERS.includes(urn)) {
            return;
        }
        // The YAML is designed so doc.nested is three-valued, and undefined means "test both variations"
        var contexts = [];
        if (doc.nested !== true) {
            contexts.push(Context.wholeStream);
        }
        if (doc.nested !== false) {
            contexts.push(Context.needsDelimiters);
        }
        contexts.forEach((_tct_transform_22 = (context) => {
            var _tct_transform_23;
            describe("in Context " + context, (_tct_transform_23 = function () {
                var _tct_transform_24;
                const spec = doc;
                var components;
                if (spec.coder.components) {
                    components = spec.coder.components.map((_tct_transform_24 = 
                    // Second level coders have neither payloads nor components.
                    (c) => globalRegistry().getCoder(c.urn), _tct_transform_24.__closure = () => ({ globalRegistry }), _tct_transform_24));
                }
                else {
                    components = [];
                }
                const coder = globalRegistry().getCoder(urn, undefined, ...components);
                runCoderTest(coder, urn, context, spec);
            }, _tct_transform_23.__closure = () => ({ doc, globalRegistry, urn, runCoderTest, context }), _tct_transform_23));
        }, _tct_transform_22.__closure = () => ({ describe, doc, globalRegistry, urn, runCoderTest }), _tct_transform_22));
    }, _tct_transform_21.__closure = () => ({ UNSUPPORTED_CODERS, Context, describe, globalRegistry, runCoderTest }), _tct_transform_21));
}, _tct_transform_11.__closure = () => ({ yaml, fs, STANDARD_CODERS_FILE, UNSUPPORTED_CODERS, Context, describe, globalRegistry, runCoderTest }), _tct_transform_11));
//# sourceMappingURL=standard_coders_test.js.map