"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function createOperator(transformId, context) {
    const transform = context.descriptor.transforms[transformId];
    // Ensure receivers are eagerly created.
    Object.values(transform.outputs).map(context.getReceiver);
    let operatorConstructor = operatorsByUrn.get(transform.spec.urn);
    if (operatorConstructor === null || operatorConstructor === undefined) {
        throw new Error("Unknown transform type:" + transform.spec.urn);
    }
    return operatorConstructor(transformId, transform, context);
}
var _tct_transform_1, _tct_transform_2;
createOperator.__closure = () => ({ 
    // Ensure receivers are eagerly created.
    Object, operatorsByUrn, Error });
function registerOperator(urn, cls) {
    registerOperatorConstructor(urn, (_tct_transform_1 = (transformId, transformProto, context) => {
        return new cls(transformId, transformProto, context);
    }, _tct_transform_1.__closure = () => ({ cls }), _tct_transform_1));
}
registerOperator.__closure = () => ({ registerOperatorConstructor });
function registerOperatorConstructor(urn, constructor) {
    operatorsByUrn.set(urn, constructor);
}
registerOperatorConstructor.__closure = () => ({ operatorsByUrn });
function onlyElement(arg) {
    if (arg.length > 1) {
        Error("Expecting exactly one element.");
    }
    return arg[0];
}
onlyElement.__closure = () => ({ Error });
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerOperatorConstructor = exports.registerOperator = exports.createOperator = exports.OperatorContext = exports.Receiver = exports.ProcessResultBuilder = exports.NonPromise = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("protobufjs"));
var protobufjs = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../proto/beam_runner_api"));
var PTransform = _tct_flatten_destructured_imports_2.PTransform;
var PCollection = _tct_flatten_destructured_imports_2.PCollection;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/beam_runner_api"));
var runnerApi = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../proto/beam_fn_api"));
var fnApi = _tct_flatten_destructured_imports_4;
const _tct_flatten_destructured_imports_5 = __importStar(require("../proto/beam_fn_api"));
var ProcessBundleDescriptor = _tct_flatten_destructured_imports_5.ProcessBundleDescriptor;
var RemoteGrpcPort = _tct_flatten_destructured_imports_5.RemoteGrpcPort;
const _tct_flatten_destructured_imports_6 = __importStar(require("./data"));
var MultiplexingDataChannel = _tct_flatten_destructured_imports_6.MultiplexingDataChannel;
var IDataChannel = _tct_flatten_destructured_imports_6.IDataChannel;
const _tct_flatten_destructured_imports_7 = __importStar(require("./state"));
var StateProvider = _tct_flatten_destructured_imports_7.StateProvider;
const _tct_flatten_destructured_imports_8 = __importStar(require("../internal/urns"));
var urns = _tct_flatten_destructured_imports_8;
const _tct_flatten_destructured_imports_9 = __importStar(require("../internal/pipeline"));
var PipelineContext = _tct_flatten_destructured_imports_9.PipelineContext;
const _tct_flatten_destructured_imports_10 = __importStar(require("../internal/serialize"));
var deserializeFn = _tct_flatten_destructured_imports_10.deserializeFn;
const _tct_flatten_destructured_imports_11 = __importStar(require("../coders/coders"));
var Coder = _tct_flatten_destructured_imports_11.Coder;
var CoderContext = _tct_flatten_destructured_imports_11.Context;
const _tct_flatten_destructured_imports_12 = __importStar(require("../values"));
var Window = _tct_flatten_destructured_imports_12.Window;
var Instant = _tct_flatten_destructured_imports_12.Instant;
var WindowedValue = _tct_flatten_destructured_imports_12.WindowedValue;
const _tct_flatten_destructured_imports_13 = __importStar(require("../transforms/pardo"));
var parDo = _tct_flatten_destructured_imports_13.parDo;
var DoFn = _tct_flatten_destructured_imports_13.DoFn;
var SplitOptions = _tct_flatten_destructured_imports_13.SplitOptions;
const _tct_flatten_destructured_imports_14 = __importStar(require("../transforms/window"));
var WindowFn = _tct_flatten_destructured_imports_14.WindowFn;
const _tct_flatten_destructured_imports_15 = __importStar(require("./pardo_context"));
var ParamProviderImpl = _tct_flatten_destructured_imports_15.ParamProviderImpl;
var SideInputInfo = _tct_flatten_destructured_imports_15.SideInputInfo;
var createSideInputInfo = _tct_flatten_destructured_imports_15.createSideInputInfo;
// Trying to get some of https://github.com/microsoft/TypeScript/issues/8240
exports.NonPromise = null;
class ProcessResultBuilder {
    constructor() {
        this.promises = [];
    }
    add(result) {
        if (result !== exports.NonPromise) {
            this.promises.push(result);
        }
    }
    build() {
        if (this.promises.length === 0) {
            return exports.NonPromise;
        }
        else if (this.promises.length === 1) {
            return this.promises[0];
        }
        else {
            return Promise.all(this.promises).then(() => void null);
        }
    }
}
exports.ProcessResultBuilder = ProcessResultBuilder;
class Receiver {
    constructor(operators) {
        this.operators = operators;
    }
    receive(wvalue) {
        if (this.operators.length === 1) {
            return this.operators[0].process(wvalue);
        }
        else {
            const result = new ProcessResultBuilder();
            for (const operator of this.operators) {
                result.add(operator.process(wvalue));
            }
            return result.build();
        }
    }
}
exports.Receiver = Receiver;
class OperatorContext {
    constructor(descriptor, getReceiver, getDataChannel, getStateProvider, getBundleId) {
        this.descriptor = descriptor;
        this.getReceiver = getReceiver;
        this.getDataChannel = getDataChannel;
        this.getStateProvider = getStateProvider;
        this.getBundleId = getBundleId;
        this.pipelineContext = new PipelineContext(descriptor);
    }
}
exports.OperatorContext = OperatorContext;
exports.createOperator = createOperator;
const operatorsByUrn = new Map();
exports.registerOperator = registerOperator;
exports.registerOperatorConstructor = registerOperatorConstructor;
////////// Actual operator implementation. //////////
// NOTE: It may have been more idiomatic to use objects in closures satisfying
// the IOperator interface here, but classes are used to make a clearer pattern
// potential SDK authors that are less familiar with javascript.
class DataSourceOperator {
    constructor(transformId, transform, context) {
        const readPort = RemoteGrpcPort.fromBinary(transform.spec.payload);
        this.multiplexingDataChannel = context.getDataChannel(readPort.apiServiceDescriptor.url);
        this.transformId = transformId;
        this.getBundleId = context.getBundleId;
        this.receiver = context.getReceiver(onlyElement(Object.values(transform.outputs)));
        this.coder = context.pipelineContext.getCoder(readPort.coderId);
    }
    async startBundle() {
        var _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6, _tct_transform_7;
        const this_ = this;
        var endOfDataResolve, endOfDataReject;
        this.endOfData = new Promise((_tct_transform_3 = async (resolve, reject) => {
            endOfDataResolve = resolve;
            endOfDataReject = reject;
        }, _tct_transform_3.__closure = () => ({ endOfDataResolve, endOfDataReject }), _tct_transform_3));
        await this_.multiplexingDataChannel.registerConsumer(this_.getBundleId(), this_.transformId, {
            sendData: (_tct_transform_4 = async function (data) {
                console.log("Got", data);
                const reader = new protobufjs.Reader(data);
                while (reader.pos < reader.len) {
                    const maybePromise = this_.receiver.receive(this_.coder.decode(reader, CoderContext.needsDelimiters));
                    if (maybePromise !== exports.NonPromise) {
                        await maybePromise;
                    }
                }
            }, _tct_transform_4.__closure = () => ({ console, protobufjs, this_, CoderContext, NonPromise: exports.NonPromise }), _tct_transform_4),
            sendTimers: (_tct_transform_5 = async function (timerFamilyId, timers) {
                throw Error("Not expecting timers.");
            }, _tct_transform_5.__closure = () => ({ Error }), _tct_transform_5),
            close: (_tct_transform_6 = function () {
                endOfDataResolve();
            }, _tct_transform_6.__closure = () => ({ endOfDataResolve }), _tct_transform_6),
            onError: (_tct_transform_7 = function (error) {
                endOfDataReject(error);
            }, _tct_transform_7.__closure = () => ({ endOfDataReject }), _tct_transform_7),
        });
    }
    process(wvalue) {
        throw Error("Data should not come in via process.");
    }
    async finishBundle() {
        try {
            await this.endOfData;
        }
        finally {
            this.multiplexingDataChannel.unregisterConsumer(this.getBundleId(), this.transformId);
        }
    }
}
registerOperator("beam:runner:source:v1", DataSourceOperator);
class DataSinkOperator {
    constructor(transformId, transform, context) {
        const writePort = RemoteGrpcPort.fromBinary(transform.spec.payload);
        this.multiplexingDataChannel = context.getDataChannel(writePort.apiServiceDescriptor.url);
        this.transformId = transformId;
        this.getBundleId = context.getBundleId;
        this.coder = context.pipelineContext.getCoder(writePort.coderId);
    }
    async startBundle() {
        this.channel = this.multiplexingDataChannel.getSendChannel(this.getBundleId(), this.transformId);
        this.buffer = new protobufjs.Writer();
    }
    process(wvalue) {
        this.coder.encode(wvalue, this.buffer, CoderContext.needsDelimiters);
        if (this.buffer.len > 1e6) {
            return this.flush();
        }
        return exports.NonPromise;
    }
    async finishBundle() {
        await this.flush();
        this.channel.close();
    }
    async flush() {
        if (this.buffer.len > 0) {
            await this.channel.sendData(this.buffer.finish());
            this.buffer = new protobufjs.Writer();
        }
    }
}
registerOperator("beam:runner:sink:v1", DataSinkOperator);
class FlattenOperator {
    constructor(transformId, transform, context) {
        this.receiver = context.getReceiver(onlyElement(Object.values(transform.outputs)));
    }
    async startBundle() { }
    process(wvalue) {
        return this.receiver.receive(wvalue);
    }
    async finishBundle() { }
}
registerOperator("beam:transform:flatten:v1", FlattenOperator);
class GenericParDoOperator {
    constructor(transformId, receiver, spec, payload, transformProto, operatorContext) {
        this.transformId = transformId;
        this.receiver = receiver;
        this.spec = spec;
        this.payload = payload;
        this.sideInputInfo = new Map();
        this.doFn = payload.doFn;
        this.originalContext = payload.context;
        this.getStateProvider = operatorContext.getStateProvider;
        this.sideInputInfo = createSideInputInfo(transformProto, spec, operatorContext);
    }
    async startBundle() {
        this.paramProvider = new ParamProviderImpl(this.transformId, this.sideInputInfo, this.getStateProvider);
        this.augmentedContext = this.paramProvider.augmentContext(this.originalContext);
        if (this.doFn.startBundle) {
            this.doFn.startBundle(this.augmentedContext);
        }
    }
    process(wvalue) {
        function reallyProcess() {
            const doFnOutput = this_.doFn.process(wvalue.value, this_.augmentedContext);
            if (!doFnOutput) {
                return exports.NonPromise;
            }
            const result = new ProcessResultBuilder();
            for (const element of doFnOutput) {
                result.add(this_.receiver.receive({
                    value: element,
                    windows: wvalue.windows,
                    pane: wvalue.pane,
                    timestamp: wvalue.timestamp,
                }));
            }
            this_.paramProvider.update(undefined);
            return result.build();
        }
        var _tct_transform_8;
        reallyProcess.__closure = () => ({ this_, wvalue, NonPromise: exports.NonPromise, ProcessResultBuilder });
        if (this.augmentedContext && wvalue.windows.length !== 1) {
            // We need to process each window separately.
            // TODO: (Perf) We could inspect the context more deeply and allow some
            // cases to go through.
            const result = new ProcessResultBuilder();
            for (const window of wvalue.windows) {
                result.add(this.process({
                    value: wvalue.value,
                    windows: [window],
                    pane: wvalue.pane,
                    timestamp: wvalue.timestamp,
                }));
            }
            return result.build();
        }
        const this_ = this;
        // Update the context with any information specific to this window.
        const updateContextResult = this.paramProvider.update(wvalue);
        // If we were able to do so without any deferred actions, process the
        // element immediately.
        if (updateContextResult === exports.NonPromise) {
            return reallyProcess();
        }
        else {
            // Otherwise return a promise that first waits for all the deferred
            // actions to complete and then process the element.
            return (_tct_transform_8 = async () => {
                await updateContextResult;
                const update2 = this.paramProvider.update(wvalue);
                if (update2 !== exports.NonPromise) {
                    throw new Error("Expected all promises to be resolved: " + update2);
                }
                await reallyProcess();
            }, _tct_transform_8.__closure = () => ({ updateContextResult, wvalue, NonPromise: exports.NonPromise, Error, reallyProcess }), _tct_transform_8)();
        }
    }
    async finishBundle() {
        if (this.doFn.finishBundle) {
            const finishBundleOutput = this.doFn.finishBundle(this.augmentedContext);
            if (!finishBundleOutput) {
                return;
            }
            // The finishBundle method must return `void` or a Generator<WindowedValue<OutputT>>. It may not
            // return Generator<OutputT> without windowing information because a single bundle may contain
            // elements from different windows, so each element must specify its window.
            for (const element of finishBundleOutput) {
                const maybePromise = this.receiver.receive(element);
                if (maybePromise !== exports.NonPromise) {
                    await maybePromise;
                }
            }
        }
    }
}
class IdentityParDoOperator {
    constructor(receiver) {
        this.receiver = receiver;
    }
    async startBundle() { }
    process(wvalue) {
        return this.receiver.receive(wvalue);
    }
    async finishBundle() { }
}
class SplittingDoFnOperator {
    constructor(receivers, options) {
        this.receivers = receivers;
        this.options = options;
    }
    async startBundle() { }
    process(wvalue) {
        const result = new ProcessResultBuilder();
        const keys = Object.keys(wvalue.value);
        if (this.options.exclusive && keys.length !== 1) {
            throw new Error("Multiple keys for exclusively split element: " + wvalue.value);
        }
        for (let tag of keys) {
            if (!this.options.knownTags.includes(tag)) {
                if (this.options.unknownTagBehavior === "rename") {
                    tag = this.options.unknownTagName;
                }
                else if (this.options.unknownTagBehavior === "ignore") {
                    continue;
                }
                else {
                    throw new Error("Unexpected tag '" +
                        tag +
                        "' for " +
                        wvalue.value +
                        " not in " +
                        this.options.knownTags);
                }
            }
            const receiver = this.receivers[tag];
            if (receiver) {
                result.add(receiver.receive({
                    value: wvalue.value[tag],
                    windows: wvalue.windows,
                    timestamp: wvalue.timestamp,
                    pane: wvalue.pane,
                }));
            }
        }
        return result.build();
    }
    async finishBundle() { }
}
class AssignWindowsParDoOperator {
    constructor(receiver, windowFn) {
        this.receiver = receiver;
        this.windowFn = windowFn;
    }
    async startBundle() { }
    process(wvalue) {
        const newWindowsOnce = this.windowFn.assignWindows(wvalue.timestamp);
        if (newWindowsOnce.length > 0) {
            // Each element from each original window is assigned to the new windows.
            const newWindows = [];
            for (var i = 0; i < wvalue.windows.length; i++) {
                newWindows.push(...newWindowsOnce);
            }
            return this.receiver.receive({
                value: wvalue.value,
                windows: newWindows,
                timestamp: wvalue.timestamp,
                pane: wvalue.pane,
            });
        }
        else {
            return exports.NonPromise;
        }
    }
    async finishBundle() { }
}
class AssignTimestampsParDoOperator {
    constructor(receiver, func) {
        this.receiver = receiver;
        this.func = func;
    }
    async startBundle() { }
    process(wvalue) {
        return this.receiver.receive({
            value: wvalue.value,
            windows: wvalue.windows,
            // TODO: Verify it falls in window and doesn't cause late data.
            timestamp: this.func(wvalue.value, wvalue.timestamp),
            pane: wvalue.pane,
        });
    }
    async finishBundle() { }
}
registerOperatorConstructor(parDo.urn, (_tct_transform_2 = (transformId, transform, context) => {
    var _tct_transform_9;
    const receiver = context.getReceiver(onlyElement(Object.values(transform.outputs)));
    const spec = runnerApi.ParDoPayload.fromBinary(transform.spec.payload);
    // TODO: (Cleanup) Ideally we could branch on the urn itself, but some runners have a closed set of known URNs.
    if (spec.doFn?.urn === urns.SERIALIZED_JS_DOFN_INFO) {
        return new GenericParDoOperator(transformId, context.getReceiver(onlyElement(Object.values(transform.outputs))), spec, deserializeFn(spec.doFn.payload), transform, context);
    }
    else if (spec.doFn?.urn === urns.IDENTITY_DOFN_URN) {
        return new IdentityParDoOperator(context.getReceiver(onlyElement(Object.values(transform.outputs))));
    }
    else if (spec.doFn?.urn === urns.JS_WINDOW_INTO_DOFN_URN) {
        return new AssignWindowsParDoOperator(context.getReceiver(onlyElement(Object.values(transform.outputs))), deserializeFn(spec.doFn.payload).windowFn);
    }
    else if (spec.doFn?.urn === urns.JS_ASSIGN_TIMESTAMPS_DOFN_URN) {
        return new AssignTimestampsParDoOperator(context.getReceiver(onlyElement(Object.values(transform.outputs))), deserializeFn(spec.doFn.payload).func);
    }
    else if (spec.doFn?.urn === urns.SPLITTING_JS_DOFN_URN) {
        return new SplittingDoFnOperator(Object.fromEntries(Object.entries(transform.outputs).map((_tct_transform_9 = ([tag, pcId]) => [
            tag,
            context.getReceiver(pcId),
        ], _tct_transform_9.__closure = () => ({ context }), _tct_transform_9))), deserializeFn(spec.doFn.payload));
    }
    else {
        throw new Error("Unknown DoFn type: " + spec);
    }
}, _tct_transform_2.__closure = () => ({ onlyElement, Object, runnerApi, urns, GenericParDoOperator, deserializeFn, IdentityParDoOperator, AssignWindowsParDoOperator, AssignTimestampsParDoOperator, SplittingDoFnOperator, Error }), _tct_transform_2));
//# sourceMappingURL=operators.js.map